/* Prototype definitions

  (c) 1995 Yves Debilloez

  This file is part of CHESS.

  CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY.  No author or distributor accepts responsibility to anyone for
  the consequences of using it or for whether it serves any particular
  purpose or works at all, unless he says so in writing.  Refer to the CHESS
  General Public License for full details.

  Everyone is granted permission to copy, modify and redistribute CHESS, but
  only under the conditions described in the CHESS General Public License. A
  copy of this license is supposed to have been given to you along with
  CHESS so you can know your rights and responsibilities.  It should be in a
  file named COPYING.  Among other things, the copyright notice and this
  notice must be preserved on all copies.

*/

/* from gnuchess.c */

unsigned int Px rand1 (void);
void Px srand1 (unsigned int seed);
inline void Px Initialize_dist (void);
void Px Initialize_moves (void);
int main (int argc, char **argv);
#ifndef ZTablDepth
void Px ZeroTTable (void);
#endif
void Px NewGame (void);
#ifndef INMACS
inline void Px pick (short int p1,short int p2);
#endif
void Px SelectMove (short int side,short int iop);
void Px OpeningBook (void);
#ifndef RPTMAC
inline void Px repetition (short int *cnt);
#endif
int Px search (short int side, short int ply,
					short int depth, short int alpha,
					short int beta, short unsigned int *bstline,
					short int *rpt);
int Px ProbeTTable (short int side, short int depth,
						  short int *alpha, short int *beta,
						  short int *score);
void Px PutInTTable (short int side, short int score,
							short int depth, short int alpha,
							short int beta, short unsigned int mv);
int Px ProbeFTable(short int side, short int depth,
						 short int *alpha, short int *beta,
						 short int *score);
void Px PutInFTable (short int side, short int score,
							short int depth, short int alpha,
							short int beta, short unsigned int f,
							short unsigned int t);
void Px ZeroRPT (void);
void Px MoveList (short int side,short int ply);
void Px CaptureList (short int side,short int xside, short int ply);
void Px UpdateHashbd (short int side,short int piece,
							 short int f,short int t);
int  Px castle (short int side,short int kf,
					 short int kt, short int iop);
inline void Px EnPassant (short int xside,short int f,
								  short int t,short int iop);
inline void Px UpdatePieceList (short int side,short int sq,short int iop);
void Px MakeMove (short int side,struct leaf Fr * node,
						short int *tempb,short int *tempc,
						short int *tempsf,short int *tempst);
void Px UnmakeMove (short int side,struct leaf Fr *node,
						  short int *tempb,short int *tempc,
						  short int *tempsf,short int *tempst);
void Px InitializeStats (void);
int  Px SqAtakd (short int sq,short int side);
inline void Px ataks (short int side,short int *a);
int Px evaluate (short int side,short int xside,
					  short int ply,short int alpha,short int beta);
void Px ScorePosition (short int side,short int *score);
void Px ScoreLoneKing (short int side,short int *score);
int Px ScoreKPK (short int side,short int winner,
					  short int loser,short int king1,
					  short int king2,short int sq);
int Px ScoreKBNK (short int winner,short int king1,short int king2);
int Px SqValue (short int sq,short int side);
void Px KingScan (short int sq,short int *s);
int  Px trapped (short int sq,short int piece);
void Px ExaminePosition (void);
void Px UpdateWeights (void);

/* from pcdsp.c */

void Px Initialize (void);
void Px ExitChess (void);
void Px surelow(char *target);
void Px ShowMessage (char *s);
void Px ClearMessage (void);
#ifdef MSDOS
void Die (void);
#else
void Die (int sig);  /* I am not sure about this yde */
#endif
#ifdef MSDOS
void TerminateSearch (void);
#else
void TerminateSearch (int sig);
#endif
void Px algbr (short int f,short int t,short int flag);
void Px seteasy (short call_param);
int Px  VerifyMove (char *s,short int iop,short unsigned int *mv);
void Px EditBoard (short xc);
void Px help (void);
void Px ShowDepth (char ch,short min,short max);
void Px ShowResults (short int score,short unsigned int *bstline,char ch);
void Px SearchStartStuff (short int side);
void Px OutputMove (void);
void Px ElapsedTime (short int iop);
void Px UpdateClocks (void);
void Px SetTimeControl (void);
void Px gotoXY (short int x,short int y);
void Px ClrScreen (void);
void Px ClrEoln (void);
inline Px param(short n);
void Px DrawPiece (short int sq);
void Px UpdateDisplay (short int f,short int t,
                       short int flag,short int iscastle);
void Px GetOpenings (void);
int  Px parse (FILE *fd,short unsigned int *mv,short int side);
void Px GetGame (void);
void Px SaveGame (void);
void Px ListGame (void);
void Px Undo (void);
void Px ShowSidetomove (void);
void Px PromptForMove (short passed);
void Px ShowCurrentMove (short int pnt,short int f,short int t);
void Px ChangeAlphaWindow (void);
void Px ChangeBetaWindow (void);
void Px GiveHint (void);
void Px ChangeSearchDepth (void);
void Px SetContempt (void);
void Px SetHprobe(void);
void Px ChangeXwindow (void);
void Px FileAccess(void);
void Px SelectLevel (void);
void Px ShowPostnValues (void);
void Px DoDebug (void);
void Px InputCommand (void);













