/*
  C source for GNU CHESS

  Revision: 15-01-96

  Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
  Copyright (c) 1988, 1989, 1990  John Stanback
  Copyright (c) 1990, 1991  David Giunti
  Copyright (c) 1996  Yves Debilloez

  This file is part of CHESS.

  CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY.  No author or distributor accepts responsibility to anyone for
  the consequences of using it or for whether it serves any particular
  purpose or works at all, unless he says so in writing.  Refer to the CHESS
  General Public License for full details.

  Everyone is granted permission to copy, modify and redistribute CHESS, but
  only under the conditions described in the CHESS General Public License. A
  copy of this license is supposed to have been given to you along with
  CHESS so you can know your rights and responsibilities.  It should be in a
  file named COPYING.  Among other things, the copyright notice and this
  notice must be preserved on all copies.
  gc 30b
   try changing the name of the hashfile to something else
   change rand() to rand1() to avoid lib colision
   add alternate book routine
   correct -a problems with signal
     30c
   add InChk to vars set false in newgame to aid check announcement
   changed flags in hashfile entries back to short, mite slow down 8088
      version.  There are 3 structure members named flags: some use
      16 bit logic some only 8bit.  Since padding is needed to fill these
      sturctures out in Huge model in MSC, nothing is really lost, but
      the 3 different structures need looking into...
	Fixed an arithmatic error in struct hashfile, now smaller, could have
      a larger hashfile...
     30d
   compile in small mode with some far data
   restored flags to char, short was 20% slower with no view options!
   added MSC dependent pascal keyword for faster arg passing
   trying far for the some structures, dependent
   changed hashflag clearing in newgame to keeptable active at a
      second interation of the program
	moved a couple of routines in main to allow display of the current
     book and hashfile status in the display. shouldn't be any
     side affect, but...
      30e
   fixed incorrect book name display
   moved around some calls to correctly display book name, no side effect
   reordered initiation routines.  The book is now read in before the
     clock is started and the board is displayed.
   fixed optomization problem in initilaize moves pragmas left in
      just in case...
   SHOULD defines
   SHOULDSort where the comments about _should_ are taken
        in initilalize_moves  Not taken in 30e. slows down version f!
	SHOULDBeta   takes a commented out part of the hashtable
        probe code that affects bata ...Keep undefined .
   Mike Blair noted that -a is not kept in newgame, it now is, ahead made
      global (from main) to accomidate
   defines MINALPHA MAXBETA added so that the alpha-beta window can be
     modified easily.  no apparent benefits from raising it to 100 so
     will leave them at 90
   added min, max parameters to ShowDepth() to display alpha & beta window
   deactivate register keyword to let optomizer do its best
	  REGISTER can be #defined to register to reactivate
   -x paramater investigated and is clobbered by newgame. It's value
     is never actually used.  Misdoced by me in 30d.  dag v30e
   added stub for -v command line mode, vicious and by MEAN define
   trying a hack in the probe section: what looks to be a bug in
     the calling logic...   Wrapped 2 ifs together with OR logic
     for slightly faster performence. Rearranged tests for faster
     fall through.  I need to get the original unix version with the
     full core hashfile to see what was changed here to use the
     file hash system. Added TRYit define to activate this section.
   added test for post before calling showresult().  It is only used
     if post is active, so checking here should save time when post
     is not selected.. ie faster in tournament style.  Removed test
	  in display code.
   made UpdateHashbd() a macro
   added another group of defines to simulate the inline functions as
     macros. I removed white space in most of these macros because
     MSC 51 is limited to 512 bytes for macro expansion, and that was
     not enough.  Other compilers may have similar problems.
     Since the code that follows each macro is exactly the same
     as the functions, update both (!) if needed. This is UGLY
     but it is maintainable and faster.  Had to remove the if memset
	  define from these macros... take note .
     INMACS triggers pick(), ataks(), and UpdateHashbd()
     LINKmMAC  Linkmove()  lots of problems with this.  Found the bug
                           flag is modified and must be duped in this
                           function to avoid side effect.
     GENmMAC   Genmoves
     BRSMAC   BRscan()
     BLENDbMAC  blendboard()
     COPYbMAC  copyboard()
     ZTablDepth  ZeroTTable()  also simplified this fcn
       genmoves/Link/linkmoves macro too complex.
       linkmoves() too large ...    squashed it
           MSC doesn't like constants (defined as int value)
			for a passed paramteter to linkmoves so I will try an pass
         them as a variables assigned to value needed for call
         flag0, fcstlflag, fc etc.
           Genmoves() has trouble expanding with linkmoves included, so
         a split up the macro for genmoves and call it by constructing
         it inline in parts with seperate calls for linkmoves at each
         call point.
      hacks   Tried to no effect:
         try uncommenting the zerottable and see what happens. .. slightly
			  slower but same results.
   zerottable made a macro.  slightly slower when commented out sections
     are taken and .lst show less total depth reached.
   Changed the names of two constants. upperbound is now AlphaBound
     lowerbound is now BetaBound.  These two look to be missnamed since
     alpha is the low and beta is the high bounds of the checking system
     Perhaps I don't understand how logic works in the hashfile section
     but atleast these two will be correctly named.

 -v30f
   the flag f1 in linkmoves is the solution to the problem.
     removed ML from macro passing, restored s-2000 in linkmove call
   added parens in link around ply increment reference. no solution
	  but no harm.
   changed aliased flag to f1 in linkmoves so that when flag is modified
     in the function it is not retained on return.
   hashfile hacks:  moved depth check to before table check to avoid posible
     colisions at depth.  now forced into file before rehash can cause
     problems. in both probe and putin code.  Entries <= rehash go to the
     table, above go to the file.
     rehash takes max depth if the file is not active.
     I think that frehash could be modified to a setting close
	  to maximum depth...???
   add define FILETEST to simulate the HASHTEST code for file usage
     should save a lot of disk space and a small amount of time for
     checking the board.
   revised the hashfile system.  Now the index is the entry point for
     storage and search. Eliminates the posibility of not storing or
     retrieving something because that entry is filled.  Slightly
     slower, but more complete.  The address ANDing wraps around so
     an end check is not necessary.  Could run into a problem when the
     file is completly full though.   May need to make the size of the
     file a parameter for the -t option.
   Trying an early read into the hashfile, if it exists it should be
     checked early in the search.  removed this section and integrated
	  functionality into the tofileat system.
   adding rpthash array and access from GC31, to limit calls
     to repetition().  Added cast to short in the array references to
     rpthash[].  As used in gc31 they requied conversion to long, should
     be a bit faster, and sign extension of 0xff could be dangerous so
     changed it to 0x00ff (not needed).
       while operating faster, a move with lesser value (than code before
       this rpthash code was added) is taken.
         added a ZeroRPT call after rpt is set to 0 in select move:
			  not kept slows the system down.
         the mystery could be the timeout exit after '&' display which
           returns ply-1...???  though the pxp move is kept at deeper
           levels in the earliner versions..
         Making rpthash[] larger  511 rather than 255
    added RPTMAC define to trigger repetition() as a macro,
        This seems to slow down execution, but will leave code in incase
           someone wants to experiment.
    added two if tests from 31
    added LONEKING define, to trigger new lone king score, doesn't work
           in scoreloneking fcn, retruns value correctly but is not used
           correctly.
         moved material check to search() function draw assignment logic
			  works to signal draw when condition is reached, but I am not
           sure it will correctly predict the draw condition, and I am not
           sure if GC is set up deal correctly with drawing as a partial
           winning condition.
         By define so depth can be checked easily.
    coding a different system for hashfile access.  Adding variable
      ToFileAt which will contain the value to use for first access to
       the hashfile... rather than useing rehash to hold this.  Will be
       set from the Your Move prompt and default to 4.  If the hashfile
		 is not found set to maxdepth.
    added MSDOS spacific code to pause before making the disk file,
       in case it is a one disk system...
    reworked -a code.  moved setting into newgame ONLY. having seteasy()
       in display section also reset ahead when easy is turned off.
    discovered bad bug in table code.  Each depth has a different storage
       level, but the probe code only finds the first depth entered
    recoded all table access to match file access.
        added limits on search
    coded possible far instead of huge use of table,
        could be new ->hashbd == 0 tests, so code in but not taken now..
        can doubled size of ttable, but requires back to huge
        deep tests (matein4 show that the far ttable can be 28% faster
		  so back to far and away from huge.
    added a short cast to hashkey references in ttable code, also short
       cast on != 0 code in same sections.
       oddly (short) haskhey slows things down.  I will try useing a short
       cast to a temp variable and then use that.  It may be that
       instead of truncating this value (never really needs to be
       the long it is) is done by loading and discarding rather than
       truncating the variable itself.
    removed 2* in ttcode for speed check , with can be 20% slower
					 in deep searches!
    recoded rehash to 6.  It is more effieicent for some reason?
    removed != 0 from refs in ttcode, use existancs logic
    folding references to hashkey (only used as a 16 bit value, but
       computed to 32bits) together with Xor ^ . this slows greatly!
       so it is not taken
    dereferencing ttable references so that the larger version can
       also be far rather than huge, even with the test code included.
       This mod can be made to work, but it is much slower(!) so it's
       back to huge for ttable

   (future note) add routine in ScoreLoneKing() to assign a draw if there
     are only 2 kings left on the board.  Its handy for testing Depth limits
	  but it is an error!  Added some code for this, not sure if it is complete
          Possible problem surfaces in 2kings test.  When checking hashfile
     usage, the file is checked and the depth is updated to reflect the
     encoded moves, but the bestline display doesn't reflect the full
     chain of best moves...  it shows the internal checks, but when
     the file is checked, the display removes the newer ones and does
     not add more.  I suspct this is related to an assignment based on
     ply, or the way that the the probe calls are now made (2 levels
     rather than the 1 from the original unix port
			ply is generated by search( and is always 1 with this call
             seems always to be increased by interative calls to score
             ???
         the last plys 26 to 29 seem to be never printed.. need to
         find out why.
   look to removing bd from the file system and replace it with a
     smaller logical value.. xor or something similar to current
     ram based system. will save several megs of disk space.   DONE

*/

#include <stdio.h>
/* <stdio.h */
#ifndef MSDOS   /* redefed in stdio.h */
extern int fprintf ();
extern int fflush ();
#endif

#define SEEK_SET 0
#define SEEK_END 2
#include <ctype.h>

/*
  ttblsz must be a power of 2.
  Setting ttblsz 0 removes the transposition tables.
*/
#ifdef MSDOS
#include <stdlib.h>
#include <time.h>
#define ttblsz 2048    /* can be 4096 in 30f if no HASHTEST and you
                          use  huge definition  dag */
                       /* is 2048 in v30   dag */
                       /* 2048 * 2 * 16 = 65536 if HASHTEST is off,
                          ok for far  */

#ifndef HASHTEST       /* only define NonHuge if msdos and ttblsz 2048 !
                          or you can use far instead of huge without
                          a speed penalty  dag */
#define NonHuge
#endif

#include <string.h>    /* for strcpy */

#else
#include <sys/param.h>
#include <sys/types.h>
#include <sys/times.h>
#define ttblsz 65536
#define huge
#endif /* MSDOS */

#ifndef MSDOS  /* duped definitions */
/* <stdlib.h> */
extern int abs ();
extern int atoi ();
/* <time.h> */
extern long int time ();
/* <string.h> */
extern void *memset ();
#endif

#ifdef MSDOS
#define Px pascal     /* to activate faster function calls  dag */
#define Fr far        /*  to activate faster data calls */

#ifdef NonHuge        /* if huge not required use far in msdos  dag */
#define Hu far        /* define far if huge is not needed */
#else
#define Hu huge       /*  for huge storage class */
#endif

#define REGISTER      /* turn of programmer defined allocations */
#define MEAN          /* turn on visious mode to check */

#ifndef inline        /* if inline is not defined generate inline
                         macros instead
                         even with a compiler that handles inline
                         these may be faster than use of that
                         facility */
#define INMACS        /* turns on inline simulateion via macros
                         for pick(), ataks(), and UpdateHashbd() */
#define LINKmMAC      /* turn on macro generation for linkmoves */
#define GENmMAC       /* turns on macro generation for Genmoves */
#define BRSMAC        /* turns on macro gen for BRScan */
#define BLENDbMAC     /* turns on macro gen for Blendboard */
#define COPYbMAC      /* turns on Copyboard macro */
#define ZTablDepth    /* turns on macro for ZeroTTable  */
/* #define RPTMAC */    /* this macro slows down by about 5%. Could be
									difference in jump sizes in the 8088
                           do not use it without checking */
                      /* truns on macro for repetition */
#endif    /* is inline defined */

#define LONEKING      /* turn on lone king deaw  */
            /* not working returns ok, but gets abs() somewhere and does not
               trigger draw  ***************/
#define TRYit         /* uses compound logic in table probes */
/* #define SHOULDSort */   /* turns on sorting in move generatiron routine */
                           /* should sort looks attractive, slightly slower
                              when taken in version f  */
/* #define SHOULDBeta  */  /* takes a commented out part of the hashtable
								 probe code that affects bata
                         does not appear to be usefull */
/* #define LOOPPRAG */      /* to turn on loop optomization pragma
                             in initilaize moves, eliminated need  dag */

#else
#define Px            /* null if not activated */
#define Fr            /* " " */
#define Hu
#define REGISTER  register   /* allow register keyword for non reg
                               coloring C compilers */
#endif

extern char bk_title[]; /* in uxdskp, contains title of opening book */
#define MINALPHA    90   /* for minimax search. should allow queen
                            sacrafices to be considered. dag */
#define MAXBETA     90

#include "gnuchess.h"

#define bpawn 7
#define valueP 100
#define valueN 350
#define valueB 355
#define valueR 550
#define valueQ 1100
#define valueK 1200
#define ctlP 0x4000
#define ctlN 0x2800
#define ctlB 0x1800
#define ctlR 0x0400
#define ctlQ 0x0200
#define ctlK 0x0100
#define ctlBQ 0x1200
#define ctlRQ 0x0600
#define ctlNN 0x2000
#define maxdepth 30          /* also defined in pcdsp and gnuchess.h */

#if ttblsz
#define truescore 0x0001
#define BetaBound 0x0002    /* was lowerbound in previous versions */
#define AlphaBound 0x0004   /* was upperbound in previous versions */
#define kingcastle 0x0008
#define queencastle 0x0010

struct hashval
{
  unsigned long key,bd;
};
struct hashentry
{
  unsigned long hashbd;
  unsigned short mv;
  unsigned char flags, depth;   /* can be short,
                                   was char saves some space,
                                  but it could be logiced with larger values
                            looks like a bug, but isnt   fix padding too...*/
  short score;    /* 12 bytes, needs 4 for padding  to 16 with short flags */
                  /* 10 bytes as chars need 6 to 16  */
#ifdef HASHTEST
  unsigned char bd[32];  /*44 bytes needs 20 for padding with short flags */
                         /*42 with char needs 22 for pad */
#ifndef NonHuge
  char pad[22] ;  /* fill out for huge */
#endif
#else

#ifndef NonHuge   /* dont pad if can be far  */
  char pad[6];   /* pad if no test */
#endif
#endif /* HASHTEST */

};

#ifdef __BORLANDC__
#include "declare.h"
#include <conio.h>
#endif

/*
  In a networked enviroment gnuchess might be compiled on different
  hosts with different random number generators, that is not acceptable
  if they are going to share the same transposition table.
     moved out of if hashfile block for non has testing
*/

unsigned long int next = 1;

unsigned int Px rand1 ()
{
  next *= 1103515245L;
  next += 12345;
  return ((unsigned int) (next >> 16) & 0xFFFF);
}

void Px srand1 (seed)
     unsigned int seed;
{
  next = seed;
}

#ifdef HASHFILE
/*
  persistent transposition table.
  The size must be a power of 2. If you change the size,
  be sure to run gnuchess -t before anything else.
*/
#define frehash 6

#define filesz 131072L           /* 65536 * 2 */
struct fileentry
{
  unsigned long HashBd;
#ifdef FILETEST
  unsigned char bd[32];
#endif
  unsigned char f, t, flags, depth, sh, sl;
};

#endif /* HASHFILE */

static unsigned long hashkey, hashbd;
static struct hashval hashcode[2][7][64];

static struct hashentry Hu ttable[2][ttblsz];
#if 0    /* sort of declaration needed for far use of ttable   dag */
struct hashentry Hu *ttable[2];   /* 2 pointers to the object */
struct hashentry Hu whitetable[ttblsz];   /* declare the tables themselves */
struct hashentry Hu blacktable[ttblsz];   /* now needs initialization  */
#endif     /* nulled out declarations */

#endif /* ttblsz */

#define RPTHSize   512            /* was originally 256  dag */
#define RPTHMask   0x1ff          /* was 0xff in original   dag */
static short rpthash[2][RPTHSize];     /* transfered from GC31    dag */


FILE *hashfile;
#ifdef MSDOS
struct leaf Fr Tree[2000];
struct leaf Fr *root = Tree;
#else
struct leaf Tree[2000], *root = Tree;
#endif

short TrPnt[maxdepth + 4];        /* may need larger buffer  addressed
                                  with ply + 1 several times.. 4 for
                                  safety    dag */
short PieceList[2][16], PawnCnt[2][8];
short castld[2], Mvboard[64];
short c1, c2, *atk1, *atk2, *PC1, *PC2, atak[2][64];
short mate, post, opponent, computer, Sdepth, Awindow, Bwindow, dither;
short ahead,                 /* made global to carry -a through newgame */
		vicious;                    /* a signal value for more human play */
long ResponseTime, ExtraTime, Level, et, et0, time0, ft;
long NodeCnt, ETnodes, EvalNodes, HashCnt, FHashCnt, HashCol;
short quit, reverse, bothsides, hashflag, InChk, player, force, easy, beep;
short timeout, xwndw, rehash;
short ToFileAt;            /* to hold the file access after depth var  dag */
struct GameRec GameList[500];
short GameCnt, Game50, epsquare, lpost, rcptr, contempt;
short MaxSearchDepth;
struct BookEntry Fr *Book;
struct TimeControlRec TimeControl;
short TCflag, TCmoves, TCminutes, OperatorTime;
const short otherside[3] =
{1, 0, 2};
unsigned short hint, PrVar[maxdepth];

static short Pindex[64], svalue[64];
static short PieceCnt[2];
static short mtl[2], pmtl[2], emtl[2], hung[2];
static short EnemyKing;
static short wking, bking, FROMsquare, TOsquare, Zscore, zwndw, slk;
static short INCscore;
static short HasPawn[2], HasKnight[2], HasBishop[2], HasRook[2], HasQueen[2];
static short ChkFlag[maxdepth], CptrFlag[maxdepth], PawnThreat[maxdepth];
static short Pscore[maxdepth], Tscore[maxdepth];
static const short qrook[3] =
{0, 56, 0};
static const short krook[3] =
{7, 63, 0};
static const short kingP[3] =
{4, 60, 0};
static const short rank7[3] =
{6, 1, 0};
static const short sweep[7] =
{false, false, false, true, true, true, false};
static unsigned short killr0[maxdepth], killr1[maxdepth], killr2[maxdepth];
static unsigned short killr3[maxdepth];
static unsigned short PV, Swag0, Swag1, Swag2, Swag3, Swag4;
static unsigned char history[8192];   /* 4096 * 2 */

static short Mwpawn[64], Mbpawn[64], Mknight[2][64], Mbishop[2][64];
static short Mking[2][64], Kfield[2][64];
static const short value[7] =
{0, valueP, valueN, valueB, valueR, valueQ, valueK};
static const short control[7] =
{0, ctlP, ctlN, ctlB, ctlR, ctlQ, ctlK};
static const short PassedPawn0[8] =
{0, 60, 80, 120, 200, 360, 600, 800};
static const short PassedPawn1[8] =
{0, 30, 40, 60, 100, 180, 300, 800};
static const short PassedPawn2[8] =
{0, 15, 25, 35, 50, 90, 140, 800};
static const short PassedPawn3[8] =
{0, 5, 10, 15, 20, 30, 140, 800};
static const short ISOLANI[8] =
{-12, -16, -20, -24, -24, -20, -16, -12};
static const short BACKWARD[16] =
{-6, -10, -15, -21, -28, -28, -28, -28,
 -28, -28, -28, -28, -28, -28, -28, -28};
static const short BMBLTY[14] =
{-2, 0, 2, 4, 6, 8, 10, 12, 13, 14, 15, 16, 16, 16};
static const short RMBLTY[15] =
{0, 2, 4, 6, 8, 10, 11, 12, 13, 14, 14, 14, 14, 14, 14};
static const short KTHRT[36] =
{0, -8, -20, -36, -52, -68, -80, -80, -80, -80, -80, -80,
 -80, -80, -80, -80, -80, -80, -80, -80, -80, -80, -80, -80,
 -80, -80, -80, -80, -80, -80, -80, -80, -80, -80, -80, -80};
static short KNIGHTPOST, KNIGHTSTRONG, BISHOPSTRONG, KATAK, KBNKsq;
static short PEDRNK2B, PWEAKH, PADVNCM, PADVNCI, PAWNSHIELD, PDOUBLED, PBLOK;
static short RHOPN, RHOPNX, KHOPN, KHOPNX, KSFTY;
static short ATAKD, HUNGP, HUNGX, KCASTLD, KMOVD, XRAY, PINVAL;
static short stage, stage2, Zwmtl, Zbmtl, Developed[2], PawnStorm;
static short PawnBonus, BishopBonus, RookBonus;
static const short KingOpening[64] =
{0, 0, -4, -10, -10, -4, 0, 0,
 -4, -4, -8, -12, -12, -8, -4, -4,
 -12, -16, -20, -20, -20, -20, -16, -12,
 -16, -20, -24, -24, -24, -24, -20, -16,
 -16, -20, -24, -24, -24, -24, -20, -16,
 -12, -16, -20, -20, -20, -20, -16, -12,
 -4, -4, -8, -12, -12, -8, -4, -4,
 0, 0, -4, -10, -10, -4, 0, 0};
static const short KingEnding[64] =
{0, 6, 12, 18, 18, 12, 6, 0,
 6, 12, 18, 24, 24, 18, 12, 6,
 12, 18, 24, 30, 30, 24, 18, 12,
 18, 24, 30, 36, 36, 30, 24, 18,
 18, 24, 30, 36, 36, 30, 24, 18,
 12, 18, 24, 30, 30, 24, 18, 12,
 6, 12, 18, 24, 24, 18, 12, 6,
 0, 6, 12, 18, 18, 12, 6, 0};
static const short DyingKing[64] =
{0, 8, 16, 24, 24, 16, 8, 0,
 8, 32, 40, 48, 48, 40, 32, 8,
 16, 40, 56, 64, 64, 56, 40, 16,
 24, 48, 64, 72, 72, 64, 48, 24,
 24, 48, 64, 72, 72, 64, 48, 24,
 16, 40, 56, 64, 64, 56, 40, 16,
 8, 32, 40, 48, 48, 40, 32, 8,
 0, 8, 16, 24, 24, 16, 8, 0};
static const short KBNK[64] =
{99, 90, 80, 70, 60, 50, 40, 40,
 90, 80, 60, 50, 40, 30, 20, 40,
 80, 60, 40, 30, 20, 10, 30, 50,
 70, 50, 30, 10, 0, 20, 40, 60,
 60, 40, 20, 0, 10, 30, 50, 70,
 50, 30, 10, 20, 30, 40, 60, 80,
 40, 20, 30, 40, 50, 60, 80, 90,
 40, 40, 50, 60, 70, 80, 90, 99};
static const short pknight[64] =
{0, 4, 8, 10, 10, 8, 4, 0,
 4, 8, 16, 20, 20, 16, 8, 4,
 8, 16, 24, 28, 28, 24, 16, 8,
 10, 20, 28, 32, 32, 28, 20, 10,
 10, 20, 28, 32, 32, 28, 20, 10,
 8, 16, 24, 28, 28, 24, 16, 8,
 4, 8, 16, 20, 20, 16, 8, 4,
 0, 4, 8, 10, 10, 8, 4, 0};
static const short pbishop[64] =
{14, 14, 14, 14, 14, 14, 14, 14,
 14, 22, 18, 18, 18, 18, 22, 14,
 14, 18, 22, 22, 22, 22, 18, 14,
 14, 18, 22, 22, 22, 22, 18, 14,
 14, 18, 22, 22, 22, 22, 18, 14,
 14, 18, 22, 22, 22, 22, 18, 14,
 14, 22, 18, 18, 18, 18, 22, 14,
 14, 14, 14, 14, 14, 14, 14, 14};
static const short PawnAdvance[64] =
{0, 0, 0, 0, 0, 0, 0, 0,
 4, 4, 4, 0, 0, 4, 4, 4,
 6, 8, 2, 10, 10, 2, 8, 6,
 6, 8, 12, 16, 16, 12, 8, 6,
 8, 12, 16, 24, 24, 16, 12, 8,
 12, 16, 24, 32, 32, 24, 16, 12,
 12, 16, 24, 32, 32, 24, 16, 12,
 0, 0, 0, 0, 0, 0, 0, 0};


/* .... MOVE GENERATION VARIABLES AND INITIALIZATIONS .... */


#define taxicab(a,b) taxidata[a][b]
short distdata[64][64], taxidata[64][64];

inline void Px               /* non macroed only called once   dag */
Initialize_dist ()
{
  REGISTER short a, b, d, di;

  for (a = 0; a < 64; a++)
    for (b = 0; b < 64; b++)
      {
	d = abs (column (a) - column (b));
	di = abs (row (a) - row (b));
	taxidata[a][b] = d + di;
	distdata[a][b] = (d > di ? d : di);
      }
}

const short Stboard[64] =
{rook, knight, bishop, queen, king, bishop, knight, rook,
 pawn, pawn, pawn, pawn, pawn, pawn, pawn, pawn,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 pawn, pawn, pawn, pawn, pawn, pawn, pawn, pawn,
 rook, knight, bishop, queen, king, bishop, knight, rook};
const short Stcolor[64] =
{white, white, white, white, white, white, white, white,
 white, white, white, white, white, white, white, white,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 black, black, black, black, black, black, black, black,
 black, black, black, black, black, black, black, black};
short board[64], color[64];
static unsigned char Fr nextpos[8][64][64];
static unsigned char Fr nextdir[8][64][64];
/*
  ptype is used to separate white and black pawns, like this;
  ptyp = ptype[side][piece]
  piece can be used directly in nextpos/nextdir when generating moves
  for pieces that are not black pawns.
*/
/*
 definitions should not rely on the internal representation
 so define them with sub-arrays       yde
*/
static const short ptype[2][8] =
{
  {no_piece, pawn, knight, bishop, rook, queen, king, no_piece},
  {no_piece, bpawn, knight, bishop, rook, queen, king, no_piece}};
static const short direc[8][8] =
{
  {0, 0, 0, 0, 0, 0, 0, 0},
  {10, 9, 11, 0, 0, 0, 0, 0},
  {8, -8, 12, -12, 19, -19, 21, -21},
  {9, 11, -9, -11, 0, 0, 0, 0},
  {1, 10, -1, -10, 0, 0, 0, 0},
  {1, 10, -1, -10, 9, 11, -9, -11},
  {1, 10, -1, -10, 9, 11, -9, -11},
  {-10, -9, -11, 0, 0, 0, 0, 0}};
static const short max_steps[8] =
{0, 2, 1, 7, 7, 7, 1, 2};
static const short nunmap[120] =
{
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, 0, 1, 2, 3, 4, 5, 6, 7, -1,
  -1, 8, 9, 10, 11, 12, 13, 14, 15, -1,
  -1, 16, 17, 18, 19, 20, 21, 22, 23, -1,
  -1, 24, 25, 26, 27, 28, 29, 30, 31, -1,
  -1, 32, 33, 34, 35, 36, 37, 38, 39, -1,
  -1, 40, 41, 42, 43, 44, 45, 46, 47, -1,
  -1, 48, 49, 50, 51, 52, 53, 54, 55, -1,
  -1, 56, 57, 58, 59, 60, 61, 62, 63, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};


/*
  This procedure pre-calculates all moves for every piece from every square.
  This data is stored in nextpos/nextdir and used later in the move generation
  routines.
*/

void Px
Initialize_moves ()

{
  short ptyp, po, p0, d, di, s, delta;
  unsigned char Fr *ppos, Fr *pdir;
  short dest[8][8];
  short steps[8];
  short sorted[8];
#ifdef LOOPPRAG
#pragma loop_opt(off)
#endif
  for (ptyp = 0; ptyp < 8; ptyp++)
    for (po = 0; po < 64; po++)
      for (p0 = 0; p0 < 64; p0++)
	{
      nextpos[ptyp][po][p0] =      /* try simplification, pass po through */
      nextdir[ptyp][po][p0] = (char) po;
	 }
#ifdef LOOPPRAG
 #pragma loop_opt(on)
#endif
  for (ptyp = 1; ptyp < 8; ptyp++)
    for (po = 21; po < 99; po++)
      if (nunmap[po] >= 0)
	{
      ppos = nextpos[ptyp][nunmap[po]];
	  pdir = nextdir[ptyp][nunmap[po]];
	  /* dest is a function of direction and steps */
	  for (d = 0; d < 8; d++)
	    {
	      dest[d][0] = nunmap[po];
	      delta = direc[ptyp][d];
	      if (delta != 0)
		{
		  p0 = po;
		  for (s = 0; s < max_steps[ptyp]; s++)
		    {
		      p0 = p0 + delta;
		      /*
			break if (off board) or
			(pawns only move two steps from home square)
		      */
		      if (nunmap[p0] < 0 || (ptyp == pawn || ptyp == bpawn)
			  && s > 0 && (d > 0 || Stboard[nunmap[po]] != pawn))
			break;
		      else
			dest[d][s] = nunmap[p0];
		    }
		}
	      else
		s = 0;

	      /*
	        sort dest in number of steps order
	        currently no sort is done due to compability with
	        the move generation order in old gnu chess
	      */
	      steps[d] = s;
	      for (di = d; s > 0 && di > 0; di--)
#ifndef SHOULDSort
        if (steps[sorted[di - 1]] == 0) /* should be: < s */
#else
        if (steps[sorted[di - 1]] < s)  /* now can be    dag */
#endif
          sorted[di] = sorted[di - 1];
		else
		  break;
	      sorted[di] = d;
	    }

	  /*
	    update nextpos/nextdir,
	    pawns have two threads (capture and no capture)
	  */
	  p0 = nunmap[po];
	  if (ptyp == pawn || ptyp == bpawn)
	    {
	      for (s = 0; s < steps[0]; s++)
          {
           ppos[p0] = dest[0][s];
           p0 = dest[0][s];
          }
	      p0 = nunmap[po];
			for (d = 1; d < 3; d++)
          {
		  pdir[p0] = dest[d][0];
		  p0 = dest[d][0];
          }
	    }
	  else
	    {
	      pdir[p0] = dest[sorted[0]][0];
			for (d = 0; d < 8; d++)
           for (s = 0; s < steps[sorted[d]]; s++)
           {
		    ppos[p0] = dest[sorted[d]][s];
		    p0 = dest[sorted[d]][s];
            if (d < 7)
		      pdir[p0] = dest[sorted[d + 1]][0];
		    /* else is already initialized */
           }
	    }
	}
}

/* hmm.... shouldn`t main be moved to the interface routines */

int
main (argc, argv)
     int argc;
     char **argv;
{
#ifdef MSDOS
  int hash = 1;   /* turn on internal hashfile as default, will auto trigger
							search for file on disk   dag */
#else
  int hash = 0;
#endif
  char *xwin = 0;

  vicious = ahead = 0;
  ToFileAt = 4;              /* set default for hash file access after  dag */
  rehash = 6;                /* set to default  dag */

  while (argc > 1 && argv[1][0] == '-')
    {
	 switch (argv[1][1])
		{
	 case 'b':
		strcpy(bk_title, &argv[1][2]);
		break ;
	 case 'a':
#ifdef MSDOS
		fprintf (stderr," REMEMBER...\n\n");
		fprintf (stderr,"   while the computer is thinking on your time\n");
		fprintf (stderr,"   you will have to press <ctrl>C or <ctrl><break>\n");
		fprintf (stderr,"   to get it\'s attention to take your move!\n");
		for (ahead = 32000; ahead > 0 ; ahead--) ;   /* dramatic pause */
#endif
		ahead = 1;
		break;
#ifdef MEAN
	 case 'v':        /* added stub for vicious mode */
		vicious = true;
		break;
#endif
	 case 'h':
		hash = 1;
		break;
#if ttblsz
#ifdef HASHFILE
	 case 't': /* create or test persistent transposition table */
		{
#ifdef MSDOS    /* need binary mode in commands */
		  fprintf(stderr,"Press a key to begin filling diskfile\n");
		  while (!kbhit());  /* pause incase 1 disk drive  dag */

		  if ((hashfile = fopen ("hashtest", "rb+")) == NULL)
			 hashfile = fopen ("hashtest" , "wb+");
#else
		  if ((hashfile = fopen ("hashtest", "r+")) == NULL)
			 hashfile = fopen ("hashtest" , "w+");
#endif
		  if (hashfile != NULL)
			{
		long i, j;
		int nr[maxdepth];
		struct fileentry n;

		printf("Counting transposition file entries, wait!\n");
		for(i = 0; i < maxdepth; i++) nr[i] = 0;
		fseek(hashfile, 0L, SEEK_END);
		i = ftell(hashfile) / sizeof(struct fileentry);
		fseek(hashfile, 0L, SEEK_SET);
		for (j = 0; j < i; j++)
		  {
			 fread(&n, sizeof(struct fileentry), 1, hashfile);
			 if (n.depth)
				{
			nr[n.depth]++;
			nr[0]++;
				}
		  }
#ifdef MSDOS
		  printf("The file contains %d entries out of max %ld\n",
				 nr[0], i);
#else
		  printf("The file contains %d entries out of max %d\n",
					nr[0], i);
#endif
		  for(j = 1; j < maxdepth; j++) printf("%d ",nr[j]);
		  printf("\n");
		  if (i < filesz)
		  {
			 printf("Filling transposition file, wait!\n");
				n.HashBd = 0;
#ifdef FILETEST
				for(j = 0; j < 32; j++)
				n.bd[j] = 0;
#endif
			 n.f = n.t = 0;
			 n.flags = 0;
			 n.depth = 0;
			 n.sh = n.sl = 0;
			 for (j = i; j < filesz; j++)
				fwrite(&n, sizeof(struct fileentry), 1, hashfile);
		  }
		fclose(hashfile);
			}
		 return(0);
		 break;
		}
#endif /* HASHFILE */
#endif /* ttblsz */
	 case 'x':       /* clobbered by newgame, this should go   dag*/
		xwin = &argv[1][2];
		break;

	 case '?': /* it's in the manual   yde*/
	 default:
		fprintf (stderr, "Usage: gnuchess [nn]    1 move in nn seconds\n");
		fprintf (stderr, " or gnuchess [nn] [NN]  nn moves in NN minutes\n");
		fprintf (stderr, " or gnuchess [-a] [-b] [-x xwndw]");
#ifdef HASHFILE
		fprintf (stderr, " [-h]");
#endif
#ifdef MEAN
		fprintf (stderr, " [-v]");
#endif
		fprintf (stderr, "\n");
		fprintf (stderr, "  -a   look ahead on while you are playing.\n");
		fprintf (stderr, "  -b   set path and file name for opening books.\n");
		fprintf (stderr, "  -x   min/max search choke  invalid in v30.\n");
#ifdef HASHFILE
		fprintf (stderr, "  -t   Test/create Hashfile 1280K required.\n");
		fprintf (stderr, "  -h   uses hashed transposition table.\n");
#endif
#ifdef MEAN
		fprintf (stderr, "  -v   triggers vicious mode.\n");
#endif
		fprintf (stderr, "  -?   displays this help screen.\n");
		/* yde showing options should just quit */
		return (0);
	  }
	 argv++;
	 argc--;
	 }
  Level = 0;
  TCflag = false;
  OperatorTime = 0;
  if (argc == 2)
	 Level = atoi (argv[1]);
  if (argc == 3)
	 {
		TCmoves = atoi (argv[1]);
		TCminutes = atoi (argv[2]);
		TCflag = true;
	 }
  Initialize ();
  Initialize_dist ();
  Initialize_moves ();
  if (hash)          /* moved from below newgame to signal hashfile */
	 hashflag = 1;    /* existance in the display */
  /*   moved from below newgame to show HF active if it exists */
  hashfile = NULL;
#if ttblsz
#ifdef HASHFILE
#ifdef MSDOS   /* for binary mode */
  hashfile = fopen ("hashtest", "rb+");
#else
  hashfile = fopen ("hashtest", "r+");
#endif  /* msdos */
#endif /* HASHFILE */
#endif  /* ttblsz */

  NewGame ();

  /* if (ahead)      moved into newgame to keep active with option dag
			seteasy ();   */
  if (xwin)
	 xwndw = atoi (xwin);

  /* hashfile code section was here moved up   dag*/
  while (!(quit))
    {
      if (bothsides && !mate)
	SelectMove (opponent, 1);
      else
	InputCommand ();
      if (!(quit || mate || force))
	SelectMove (computer, 1);
	 }
#if ttblsz
#ifdef HASHFILE
  if (hashfile) fclose(hashfile);
#endif /* HASHFILE */
#endif /* ttblsz */

  ExitChess ();
  return (0);
}

/* zerottable moved up to allow macro definition   dag */
#if ttblsz
#ifdef ZTablDepth
 /* simplified this function somewhat   dag */
#define ZeroTTable()  {\
  REGISTER unsigned short i;\
  if (hashflag)\
      for (i = 0; i < ttblsz; i++)\
        ttable[0][i].depth = ttable[1][i].depth = 0;\
  }

/*  whitetable[i].depth = blacktable[i].depth = 0;\  above if not huge dag*/

#else

void Px
ZeroTTable ()
{
  REGISTER int side, i;

  if (hashflag)
    for (side = 0; side < 2; side++)
      for (i = 0; i < ttblsz; i++)
	ttable[side][i].depth = 0;
}

#endif    /* ZTablDepth defined  */
#endif    /* ttblsz defined  */


void Px
NewGame ()

/*
  Reset the board and other variables to start a new game.
*/

{
  short l, c, p;

  stage = stage2 = -1;		/* the game is not yet started */
  mate = quit = reverse = bothsides = post = InChk = false;
  if (hashflag != 1)
       hashflag = false;             /* keep table active */
  force = PawnStorm = false;
  beep = rcptr = easy = true;        /* included easy dag */
  if (ahead)
       seteasy(0);                  /* keep thinking on opponents time
                                       param added  dag */
  NodeCnt = et0 = epsquare = 0;
  lpost = 8;                 /* changed from 0, is first position printed
                                with lines in post mode */
  dither = 0;
  Awindow = 90;
  Bwindow = 90;
  xwndw = 90;
  MaxSearchDepth = 29;
  contempt = 0;
  GameCnt = -1;            /* was -1, set to 0 in gc31 >?< cant find a reason
                            for either of these.  dag */
  Game50 = 0;              /* was 0, set to 1 in gc31 >?<   dag */
  Zwmtl = Zbmtl = 0;
  ZeroRPT ();                      /* added in gc31  dag */
  Developed[white] = Developed[black] = false;
  castld[white] = castld[black] = false;
  PawnThreat[0] = CptrFlag[0] = false;
  Pscore[0] = 12000;
  Tscore[0] = 12000;
  opponent = white;
  computer = black;
  for (l = 0; l < 2000; l++)
    Tree[l].f = Tree[l].t = 0;
#if ttblsz
  /* added conditional setting of ToFileAt to improve split hash system
       also added code in pcdsp to reset if HASH is used there    dag */
if (hashflag)
    if (hashfile)
		  ToFileAt = 4;
    else    ToFileAt = maxdepth;  /* set of maximum if table only dag */
#if ttblsz
#if 0   /* if nothuge assignments needed dag */
    /* add init for new ttable here   dag */
  ttable[white] = whitetable;   /* copy pointers */
  ttable[black] = blacktable;
#endif
  ZeroTTable ();
#endif /* ttblsz */
  srand1 ((unsigned int) 1);
  for (c = white; c <= black; c++)
    for (p = pawn; p <= king; p++)
		for (l = 0; l < 64; l++)
	{
      hashcode[c][p][l].key = (((unsigned long) rand1 ()));
      hashcode[c][p][l].key += (((unsigned long) rand1 ()) << 16);
      hashcode[c][p][l].bd = (((unsigned long) rand1 ()));
      hashcode[c][p][l].bd += (((unsigned long) rand1 ()) << 16);
	  if (sizeof(long) > 4)
	    {
          hashcode[c][p][l].key += (((unsigned long) rand1 ()) << 32);
			 hashcode[c][p][l].key += (((unsigned long) rand1 ()) << 48);
          hashcode[c][p][l].bd += (((unsigned long) rand1 ()) << 32);
          hashcode[c][p][l].bd += (((unsigned long) rand1 ()) << 48);
	    }
	}
#endif /* ttblsz */
  for (l = 0; l < 64; l++)
    {
      board[l] = Stboard[l];
      color[l] = Stcolor[l];
      Mvboard[l] = 0;
    }
  ClrScreen ();
  if (TCflag)
    SetTimeControl ();
  else if (Level == 0)
    SelectLevel ();
  /*  commented out.  read the book then set the clock and then play
  UpdateDisplay (0, 0, 1, 0);
  */
  InitializeStats ();
   /* elapsed time was here, moved down */
  GetOpenings ();
  time0 = time ((long *) 0);
  ElapsedTime (1);

  UpdateDisplay (0, 0, 1, 0);

}


/* ............    MOVE GENERATION & SEARCH ROUTINES    .............. */

/* called several times in time critical areas. convert to macro    dag */
#ifdef INMACS
#define pick(p1,p2) {REGISTER short p,s;short p0,s0;struct leaf temp;\
        s0=Tree[p1].score;p0=p1;for(p=p1+1;p<=p2;p++)\
        if((s=Tree[p].score)>s0){s0=s;p0=p;}\
        if(p0!=p1){temp=Tree[p1];Tree[p1]=Tree[p0];Tree[p0]=temp;}}

#else

inline void Px
pick (p1, p2)
	  short int p1;
     short int p2;

/*
  Find the best move in the tree between indexes p1 and p2. Swap the best
  move into the p1 element.
*/

{
  REGISTER short p, s;
  short p0, s0;
  struct leaf temp;

  s0 = Tree[p1].score;
  p0 = p1;
  for (p = p1 + 1; p <= p2; p++)
    if ((s = Tree[p].score) > s0)
      {
       s0 = s;
       p0 = p;
      }
  if (p0 != p1)
	 {
      temp = Tree[p1];
      Tree[p1] = Tree[p0];
      Tree[p0] = temp;
    }
}
#endif /* inmacs defined      dag */


void Px
SelectMove (side, iop)
     short int side;
     short int iop;


/*
  Select a move by calling function search() at progressively deeper ply
  until time is up or a mate or draw is reached. An alpha-beta window of -90
  to +90 points is set around the score returned from the previous
  iteration. If Sdepth != 0 then the program has correctly predicted the
  opponents move and the search will start at a depth of Sdepth+1 rather
  than a depth of 1.
*/

{
  static short i, alpha, beta, score, tempb, tempc, tempsf, tempst, xside, rpt;

  timeout = false;
  xside = otherside[side];
  if (iop != 2)
    player = side;
  if (TCflag)
    {
      if ((TimeControl.moves[side] + 3) != 0)
           ResponseTime = (TimeControl.clock[side]) /
           (TimeControl.moves[side] + 3) - OperatorTime;
      else
	ResponseTime = 0;
      ResponseTime += (ResponseTime * TimeControl.moves[side]) /
                      (2 * TCmoves + 1);
    }
  else
    ResponseTime = Level;
  if (iop == 2)
	 ResponseTime = 99999L;
  if (Sdepth > 0 && root->score > Zscore - zwndw)
    ResponseTime -= ft;
  else if (ResponseTime < 1)
          ResponseTime = 1;
  ExtraTime = 0;
  ExaminePosition ();
  ScorePosition (side, &score);
  /* Pscore[0] = -score; */
  ShowSidetomove ();

  if (Sdepth == 0)
    {
#if ttblsz
       /* ZeroTTable ();    was commented out   dag */
#endif /* ttblsz */
      SearchStartStuff (side);
#ifdef NOMEMSET
      for (i = 0; i < 8192; i++)
           history[i] = 0;
#else
      memset ((char *) history, 0, sizeof (history));
#endif /* NOMEMSET */
      FROMsquare = TOsquare = -1;
      PV = 0;
      if (iop != 2)
         hint = 0;
      for (i = 0; i < maxdepth; i++)
           PrVar[i] = killr0[i] = killr1[i] = killr2[i] = killr3[i] = 0;
      alpha = score - MINALPHA;
      beta = score + MAXBETA;
      rpt = 0;
      TrPnt[1] = 0;
      root = &Tree[0];
      MoveList (side, 1);
      for (i = TrPnt[1]; i < TrPnt[2]; i++)
           pick (i, TrPnt[2] - 1);
      if (Book != NULL)
          OpeningBook ();
      if (Book != NULL)
          timeout = true;
      NodeCnt = ETnodes = EvalNodes = HashCnt = FHashCnt = HashCol = 0;
      Zscore = 0;
      zwndw = 20;
	 }
  while (!timeout && Sdepth < MaxSearchDepth)
    {
      Sdepth++;
      ShowDepth (' ',alpha, beta);
      score = search (side, 1, Sdepth, alpha, beta, PrVar, &rpt);
      for (i = 1; i <= Sdepth; i++)
          killr0[i] = PrVar[i];
      if (score < alpha)
       {
       /* ShowDepth ('-',alpha, beta); */
       ShowDepth ('-',-9000, score);
       ExtraTime = 10 * ResponseTime;
#if ttblsz
       /* ZeroTTable ();       was commented out   dag */
#endif /* ttblsz */
       score = search (side, 1, Sdepth, -9000, score, PrVar, &rpt);
       }
      if (score > beta && !(root->flags & exact))
       {
       /* ShowDepth ('+',alpha, beta); */
       ShowDepth ('+',score, 9000);
		 ExtraTime = 0;
#if ttblsz
       /* ZeroTTable ();       was commented out   dag */
#endif /* ttblsz */
       score = search (side, 1, Sdepth, score, 9000, PrVar, &rpt);
       }
      score = root->score;
      if (!timeout)
        for (i = TrPnt[1] + 1; i < TrPnt[2]; i++)
            pick (i, TrPnt[2] - 1);
      if (post) ShowResults (score, PrVar, '.');
         for (i = 1; i <= Sdepth; i++)
             killr0[i] = PrVar[i];
      if (score > Zscore - zwndw && score > Tree[1].score + 250)
          ExtraTime = 0;
      else if (score > Zscore - 3 * zwndw)
             ExtraTime = ResponseTime;
           else
            ExtraTime = 3 * ResponseTime;
      if (root->flags & exact)
         timeout = true;
      if (Tree[1].score < -9000)
			timeout = true;
      if (4 * et > 2 * ResponseTime + ExtraTime)
         timeout = true;
      if (!timeout)
       {
       Tscore[0] = score;
       if (Zscore == 0)
          Zscore = score;
       else
	    Zscore = (Zscore + score) / 2;
       }
      zwndw = 20 + abs (Zscore / 12);
      beta = score + Bwindow;
      if (Zscore < score)
         alpha = Zscore - Awindow - zwndw;
      else
        alpha = score - Awindow - zwndw;
    }

  score = root->score;
  if (rpt >= 2 || score < -12000)
    root->flags |= draw;
  if (iop == 2)
    return;
  if (Book == NULL)
    hint = PrVar[2];
  ElapsedTime (1);

  if (score > -9999 && rpt <= 2)
    {
      MakeMove (side, root, &tempb, &tempc, &tempsf, &tempst);
      algbr (root->f, root->t, (short) root->flags);
    }
  else
    algbr (0, 0, 0);
  OutputMove ();
  if (score == -9999 || score == 9998)
    mate = true;
  if (mate)
    hint = 0;
  if ( (board[root->t] == pawn)
      || (root->flags & capture)
      || (root->flags & cstlmask))
   {  Game50 = GameCnt;
		ZeroRPT ();
   }
  GameList[GameCnt].score = score;
  GameList[GameCnt].nodes = NodeCnt;
  GameList[GameCnt].time = (short) et;
  GameList[GameCnt].depth = Sdepth;
  if (TCflag)
    {
      TimeControl.clock[side] -= (et + OperatorTime);
      if (--TimeControl.moves[side] == 0)
          SetTimeControl ();
    }
  if ((root->flags & draw) && bothsides)
    mate = true;
  if (GameCnt > 498)    /* has become 470 in 31   dag */
    mate = true; /* out of move store, you loose */
  player = xside;
  Sdepth = 0;
  fflush (stdin);
  return;
}

void Px
OpeningBook ()

/*
  Go thru each of the opening lines of play and check for a match with the
  current game listing. If a match occurs, generate a random number. If this
  number is the largest generated so far then the next move in this line
  becomes the current "candidate". After all lines are checked, the
  candidate move is put at the top of the Tree[] array and will be played by
  the program. Note that the program does not handle book transpositions.
*/

{
  short j, pnt;
  unsigned short m, Fr *mp;
  unsigned r, r0;
  struct BookEntry Fr *p;

  srand1 ((unsigned int) time0);
  r0 = m = 0;
  p = Book;
  while (p != NULL)
    {
      mp = p->mv;
      for (j = 0; j <= GameCnt; j++)
           if (GameList[j].gmove != *(mp++))
                break;
      if (j > GameCnt)
         if ((r = rand1 ()) > r0)
          {
           r0 = r;
           m = *mp;
           hint = *(++mp);
          }
       p = p->next;
    }

  for (pnt = TrPnt[1]; pnt < TrPnt[2]; pnt++)
    if (((Tree[pnt].f << 8) | Tree[pnt].t) == m)
      Tree[pnt].score = 0;
  pick (TrPnt[1], TrPnt[2] - 1);
  if (Tree[TrPnt[1]].score < 0)
    Book = NULL;
}

#ifdef RPTMAC
               /* NOTE MEMSET taken as a default, must recode if
                 your system does not support this function dag */
#define repetition(cnt) {\
 REGISTER short i, c, f, t;\
  short b[64];\
  unsigned short m;\
  *cnt = c = 0;\
  if (GameCnt > Game50 + 3)\
    {\
      memset ((char *) b, 0, sizeof (b));\
    for (i = GameCnt; i > Game50; i--)\
    {\
      m = GameList[i].gmove;\
      f = m >> 8;\
      t = m & 0xFF;\
      if (++b[f] == 0)\
        c--;\
      else\
        c++;\
      if (--b[t] == 0)\
        c--;\
      else\
        c++;\
      if (c == 0)\
        (*cnt)++;\
    }\
   }\
}

#else   /* RPTMAC not defined */

inline void Px
repetition (cnt)
     short int *cnt;

/*
  Check for draw by threefold repetition.
*/

{ REGISTER short i, c, f, t;
  short b[64];
  unsigned short m;

  *cnt = c = 0;
  if (GameCnt > Game50 + 3)
    {
#ifdef NOMEMSET
      for (i = 0; i < 64; b[i++] = 0) ;
#else
      memset ((char *) b, 0, sizeof (b));
#endif /* NOMEMSET */
      for (i = GameCnt; i > Game50; i--)
	{
	  m = GameList[i].gmove;
	  f = m >> 8;
      t = m & 0xFF;
	  if (++b[f] == 0)
	    c--;
	  else
        c++;
	  if (--b[t] == 0)
	    c--;
	  else
        c++;
      if (c == 0)
	    (*cnt)++;
	}
    }
}
#endif   /* RPTMAC defined */

int Px
search (side, ply, depth, alpha, beta, bstline, rpt)
     short int side;
     short int ply;
     short int depth;
     short int alpha;
     short int beta;
     short unsigned int *bstline;
     short int *rpt;

/*
  Perform an alpha-beta search to determine the score for the current board
  position. If depth <= 0 only capturing moves, pawn promotions and
  responses to check are generated and searched, otherwise all moves are
  processed. The search depth is modified for check evasions, certain
  re-captures and threats. Extensions may continue for up to 11 ply beyond
  the nominal search depth.
*/

#define UpdateSearchStatus \
{\
   if (post) ShowCurrentMove(pnt,node->f,node->t);\
     if (pnt > TrPnt[1])\
       {\
	  d = best-Zscore; e = best-node->score;\
	    if (best < alpha) ExtraTime = 10*ResponseTime;\
	    else if (d > -zwndw && e > 4*zwndw) ExtraTime = -ResponseTime/3;\
	    else if (d > -zwndw) ExtraTime = 0;\
	    else if (d > -3*zwndw) ExtraTime = ResponseTime;\
	    else if (d > -9*zwndw) ExtraTime = 3*ResponseTime;\
	    else ExtraTime = 5*ResponseTime;\
	    }\
	    }
#define prune (cf && score+node->score < alpha)
#define ReCapture (rcptr && score > alpha && score < beta &&\
		   ply > 2 && CptrFlag[ply-1] && CptrFlag[ply-2])
/* && depth == Sdepth-ply+1 */
#define Parry (hung[side] > 1 && ply == Sdepth+1)
#define MateThreat (ply < Sdepth+4 && ply > 4 &&\
		    ChkFlag[ply-2] && ChkFlag[ply-4] &&\
		    ChkFlag[ply-2] != ChkFlag[ply-4])

{
  REGISTER short j, pnt;
  short best, tempb, tempc, tempsf, tempst;
  short xside, pbst, d, e, cf, score, rcnt;
  unsigned short mv, nxtline[maxdepth];
  struct leaf Fr *node, tmp;

  NodeCnt++;
  xside = otherside[side];

  /* could this be removed ?   no can be decremented  dag */
  if (depth < 0)
    depth = 0;

/*  if (ply <= Sdepth + 3)         old in 30   31 adds test below  dag */
  if ((ply <= Sdepth + 3) && (rpthash[side][(short) hashkey & RPTHMask] > 0) )
   { repetition (rpt) ; }
  else
    *rpt = 0;
  /* Detect repetitions a bit earlier. SMC. 12/89 */
  if (*rpt == 1 && ply > 1)
    return (0);
  /* if (*rpt >= 2) return(0); */

  score = evaluate (side, xside, ply, alpha, beta);
  if (score > 9000)
    {
      bstline[ply] = 0;
      return (score);
    }
  if (depth > 0)
    {
      /* Allow opponent a chance to check again */
      if (InChk)
           depth = (depth < 2) ? 2 : depth;
      else if (PawnThreat[ply - 1] || ReCapture)
               ++depth;
    }
  else
    {
      if (score >= alpha &&
	  (InChk || PawnThreat[ply - 1] || Parry))
          depth = 1;
      else if (score <= beta && MateThreat)
                depth = 1;
    }

#if ttblsz
  if (depth > 0 && hashflag && ply > 1)
    {
    short filetemp;  /* temp var to hold boolean recheck  dag */
      if ( ((filetemp = depth <= ToFileAt) && \
            ProbeTTable (side, depth, &alpha, &beta, &score))
#ifdef HASHFILE
#ifdef TRYit       /* use compound logic */
     /* moved depth check up to table check was 4 is now rehash value  dag */
      || ( !filetemp && hashfile && \
      ProbeFTable (side, depth, &alpha, &beta, &score) )  );   /* new dag */
#else
        == false)
     if ((depth > 4) && hashfile )             /*  old way  dag  */
        ProbeFTable (side, depth, &alpha, &beta, &score);
#endif   /* tryit */
     /* ProbeFT returns true or false why isn't it used here ? dag
     ************
       removed "== false)" use positive logic to get at file
       use default OR to short only get to file if table fails.

       try wrapping the probe in the if,  changed abs depth check to
       user selectable ToFileAt    dag */
#else
      /* add closing to statement */ );     /* added closing )    dag */
#endif /* HASHFILE */
      bstline[ply] = PV;
      bstline[ply + 1] = 0;
      if (beta == -20000)
         return (score);
      if (alpha > beta)
         return (alpha);
    }
#endif /* ttblsz */
  if (Sdepth == 1)
    d = 7;
  else
    d = 11;
  if (ply > Sdepth + d || (depth < 1 && score > beta))
    /* score >= beta ?? */
    return (score);

  if (ply > 1)
    if (depth > 0)
      MoveList (side, ply);
    else
      CaptureList (side, xside, ply);

  if (TrPnt[ply] == TrPnt[ply + 1])
    return (score);

  cf = (depth < 1 && ply > Sdepth + 1 && !ChkFlag[ply - 2] && !slk);

  if (depth > 0)
    best = -12000;
  else
    best = score;
  if (best > alpha)
    alpha = best;

  for (pnt = pbst = TrPnt[ply];
       pnt < TrPnt[ply + 1] && best <= beta;	/* best < beta ?? */
       pnt++)
    {
      if (ply > 1)
         pick (pnt, TrPnt[ply + 1] - 1);
      node = &Tree[pnt];
      mv = (node->f << 8) | node->t;
      nxtline[ply + 1] = 0;

      if (prune)
         break;
      if (ply == 1)
         UpdateSearchStatus;

      if (!(node->flags & exact)       /* was something romoved here ?dag */
      )
	{
	  MakeMove (side, node, &tempb, &tempc, &tempsf, &tempst);
	  CptrFlag[ply] = (node->flags & capture);
	  PawnThreat[ply] = (node->flags & pwnthrt);
	  Tscore[ply] = node->score;
	  PV = node->reply;
	  node->score = -search (xside, ply + 1, depth - 1, -beta, -alpha,
				 nxtline, &rcnt);
	  if (abs (node->score) > 9000)
	    node->flags |= exact;
	  else if (rcnt == 1)
               node->score /= 2;
	  if (rcnt >= 2 || GameCnt - Game50 > 99 ||
          (node->score == 9999 - ply && !ChkFlag[ply])
#ifdef LONEKING   /* add lone king draw code as option to check depth easily
                     this may not be the place to add this mod though
                     it seems logical.  dag */
        ||  ( (mtl[white] == valueK) && (mtl[white] == mtl[black]) )
#endif  /* LONEKING option taken */

          ) /* closing bracket for if   dag */
	    {
	      node->flags |= draw;
	      node->flags |= exact;
	      if (side == computer)
              node->score = contempt;
	      else
              node->score = -contempt;
	    }
	  node->reply = nxtline[ply + 1];
	  UnmakeMove (side, node, &tempb, &tempc, &tempsf, &tempst);
	}
      if (node->score > best && !timeout)
      {
	  if (depth > 0)
	    if (node->score > alpha && !(node->flags & exact))
	      node->score += depth;
	  best = node->score;
	  pbst = pnt;
	  if (best > alpha)
	    alpha = best;
	  for (j = ply + 1; nxtline[j] > 0; j++)
	    bstline[j] = nxtline[j];
	  bstline[j] = 0;
	  bstline[ply] = mv;
	  if (ply == 1)
	    {
        if (best > root->score)
          {
		  tmp = Tree[pnt];
		  for (j = pnt - 1; j >= 0; j--)
		    Tree[j + 1] = Tree[j];
		  Tree[0] = tmp;
		  pbst = 0;
          }
        if (post && (Sdepth > 4))
          if (best > beta)
             ShowResults (best, bstline, '+');
          else if (best < alpha)
                  ShowResults (best, bstline, '-');
               else
                 ShowResults (best, bstline, '&');
	    }
	}
      if (NodeCnt > ETnodes)
          ElapsedTime (0);
      if (timeout)
          return (-Tscore[ply - 1]);
    }

  node = &Tree[pbst];
  mv = (node->f << 8) | node->t;
#if ttblsz
  if (hashflag && ply <= Sdepth && *rpt == 0 && best == alpha)
    {                 /* added test to exclude stores less than tofileat  dag */
      if (depth <= ToFileAt)
        PutInTTable (side, best, depth, alpha, beta, mv);
#ifdef HASHFILE                         /* added if and else check     dag */
      else if ( hashfile)               /* moved depth check up   dag */
           PutInFTable (side, best, depth, alpha, beta, node->f, node->t);
#endif /* HASHFILE */
     }
#endif /* ttblsz */
  if (depth > 0)
    {
      j = (node->f << 6) | node->t;
      if (side == black)
          j |= 0x1000;
      if (history[j] < 150)
           history[j] += 2 * depth;
      if (node->t != (GameList[GameCnt].gmove & 0xFF))
         if (best <= beta)
             killr3[ply] = mv;
         else if (mv != killr1[ply])
              {
               killr2[ply] = killr1[ply];
               killr1[ply] = mv;
               }
       if (best > 9000)
           killr0[ply] = mv;
       else
           killr0[ply] = 0;
    }
  return (best);
}

#if ttblsz
#define CB(i) ((color[2 * (i)] ? 0x80 : 0)\
	       | (board[2 * (i)] << 4)\
	       | (color[2 * (i) + 1] ? 0x8 : 0)\
	       | (board[2 * (i) + 1]))

int Px
ProbeTTable (side, depth, alpha, beta, score)
     short int side;
     short int depth;
     short int *alpha;
     short int *beta;
     short int *score;

/*
  Look for the current board position in the transposition table.
*/

{
  REGISTER struct hashentry Fr *ptbl;
  REGISTER unsigned short i;
  unsigned short tempHK;        /* temp variable to save translation time to
                                   index into ttable     dag */

  i = 1;                             /* i must be initialized now dag */
  tempHK = (short) hashkey;
         /* ( ((short) hashkey) ^ ((short) (hashkey >>16)) )
                too complex and slows things down  */
                                       /* holds max usable value   dag */

  ptbl = &ttable[side][ tempHK & (ttblsz - 1)];

  /* ptbl = ttable[side] + (tempHK & (ttblsz - 1)) ; non huge useage */

  /* rehash max rehash times */
  /* redone to match putintt code  dag
  for (i = 1; ptbl->hashbd != hashbd && i <= rehash; i++)
      old for turned into while code          dag    */

  while ( ptbl->hashbd && ptbl->hashbd != hashbd && i < rehash )
     ptbl = &ttable[side][(tempHK + i++) & (ttblsz - 1)];
     /* ptbl = ttable[side] +((tempHK + i++) & (ttblsz - 1)) ; nonhuge usage */
                            /* can increment temp at use, not i  dag */

    if (ptbl->depth >= depth && ptbl->hashbd == hashbd)
    {
      HashCnt++;
#ifdef HASHTEST
      for (i = 0; i < 32; i++)
      {
	  if (ptbl->bd[i] != CB(i))
	    {
	      HashCol++;
	      printf ("%c", 7);
	      break;
	    }
      }
#endif /* HASHTEST */

      PV = ptbl->mv;
      if (ptbl->flags & truescore)
      {
       *score = ptbl->score;
       *beta = -20000;  /* value is only a signal   dag */
      }
#ifdef SHOULDBeta
 /*  was #if 0   commented out, why?   (? by previous porter)
    looks correct if hasentry was at the upper bound (but upper
    bound is really values less than alpha!)  of
    the search, that should become the new lower bound for checking
       ... returned value is not used... maby not directly
       perhaps alpha should become the new value... try it!
          dag*/
      else if (ptbl->flags & AlphaBound)
           {
           if (ptbl->score < *beta) *beta = ptbl->score+1;
           }
#endif
      else if (ptbl->flags & BetaBound)
           {
            if (ptbl->score > *alpha)
               *alpha = ptbl->score - 1;
            }
      return(true);
    }  /* end if >depth and = hashbd .. else return false  */
  return(false);
}

void Px
PutInTTable (side, score, depth, alpha, beta, mv)
     short int side;
     short int score;
     short int depth;
     short int alpha;
     short int beta;
     short unsigned int mv;

/*
  Store the current board position in the transposition table.
*/

{
  REGISTER struct hashentry Fr *ptbl;
  REGISTER unsigned short i;
  unsigned short tempHK;    /* temp variable to simplify the index into
                               ttable    dag */
  i = 1 ;                             /* i must be initialized now dag */
  tempHK = (short) hashkey;
         /* ( ((short) hashkey) ^ ((short) (hashkey >>16)) )
            too complex and slow  */
                                       /* holds max usable value   dag */

  ptbl = &ttable[side][ tempHK & (ttblsz - 1)];
  /* ptbl = ttable[side] + (tempHK & (ttblsz - 1)) ; non huge usage */


  /* rehash max rehash times */
  /* this rehash system wastes rehash times table accesses. It fails in every
     case when started because hashbd is never equal to 0 ...
     it stores by depth but only retrieves by first existance of the hashbd
     now the current high level is only used
  for (i = 1; depth < ptbl->depth && ptbl->hashbd != hashbd && i <= rehash; i++)
     old and replaced  dag */

  while ( ptbl->hashbd && ptbl->hashbd != hashbd && i < rehash )
     ptbl = &ttable[side][( tempHK + i++) & (ttblsz - 1)];
     /* ptbl = ttable[side] + ((tempHK+ i++) & (ttblsz - 1)) ; non huge usage */
                       /*  can incremented temp not i at use    dag */

  if (depth > ptbl->depth || ptbl->hashbd != hashbd)
    {  /* this logic can overwrite other existing stored positions   dag */
      ptbl->hashbd = hashbd;
      ptbl->depth = depth;
      ptbl->score = score;
      ptbl->mv = mv;
      ptbl->flags = 0;
      if (score < alpha)               /* less than low bound  dag */
         ptbl->flags |= AlphaBound;    /* mark it low */
      else if (score > beta)           /* greater than highest bound ? */
             ptbl->flags |= BetaBound; /* mark it high */
           else
             ptbl->flags |= truescore; /* finally its the true value */
#ifdef HASHTEST
      for (i = 0; i < 32; i++)
       {
        ptbl->bd[i] = CB(i);
       }
#endif /* HASHTEST */
    } /* end if */
}


/* ZeroTTable() was located here.  Moved up to allow macro definition  dag */

#ifdef HASHFILE
int Px
ProbeFTable(side, depth, alpha, beta, score)
     short int side;
     short int depth;
     short int *alpha;
     short int *beta;
     short int *score;

/*
  Look for the current board position in the persistent transposition table.
*/

{
  REGISTER unsigned short i, j;
  REGISTER unsigned long hashix;
  short s;
  struct fileentry new, t;

  if (side == white)
    hashix = hashkey & 0xFFFFFFFEL & (filesz - 1);
  else
    hashix = (hashkey | 1) & (filesz - 1);
    /* added paranthesis, could be in the wrong place   yde*/

  new.HashBd = hashbd;
#ifdef FILETEST
  for (i = 0; i < 32; i++)
    new.bd[i] = CB(i);
#endif
  new.flags = 0;
  if ((Mvboard[kingP[side]] == 0) && (Mvboard[qrook[side]] == 0))
    new.flags |= queencastle;
  if ((Mvboard[kingP[side]] == 0) && (Mvboard[krook[side]] == 0))
    new.flags |= kingcastle;

      i = 0;                         /* init index counter    dag */
  /*  for (i = 0; i < frehash; i++)     redone to do while   dag */
   do {
      fseek(hashfile,
        sizeof(struct fileentry) * ((hashix + 2 * i++) & (filesz - 1)),
        SEEK_SET);                /* inc i to point at next read dag */
      fread(&t, sizeof(struct fileentry), 1, hashfile);
#ifdef FILETEST
      for (j = 0; j < 32; j++)
         if (t.bd[j] != new.bd[j])
              break;
#endif
   } while ( new.HashBd != t.HashBd && t.HashBd != 0 ) ;
                      /* null or equal are real exit conditions
                         may need feof check and reseting later !  dag */

      if ((t.depth >= depth)
#ifdef FILETEST
      && (j >= 32)
#endif
          && (new.flags == (t.flags & (kingcastle | queencastle))))
      {
        FHashCnt++;
        PV = (t.f << 8) | t.t;
        s = (t.sh << 8) | t.sl;
        if (t.flags & truescore)
         {
	      *score = s;
	      *beta = -20000;
         }
        else if (t.flags & BetaBound)
              {
               if (s > *alpha)
                   *alpha = s - 1;
              }
        return(true);
       }
 /* }      old end of for not needed now   dag */
  return(false);
}

void Px
PutInFTable (side, score, depth, alpha, beta, f, t)
     short int side;
     short int score;
     short int depth;
     short int alpha;
     short int beta;
     short unsigned int f;
     short unsigned int t;

/*
  Store the current board position in the persistent transposition table.
*/

{
  REGISTER unsigned short i;
  REGISTER unsigned long hashix;
  struct fileentry new, tmp;

  if (side == white)
    hashix = hashkey & 0xFFFFFFFEL & (filesz - 1);
  else
    hashix = (hashkey | 1) & (filesz - 1);
    /* added paranthesis,  could be in the wrong place   yde */

  new.HashBd = hashbd;
#ifdef FILETEST
  for (i = 0; i < 32; i++)
    new.bd[i] = CB(i);
#endif
  new.f = f;
  new.t = t;
  new.flags = 0;
  if (score < alpha)
    new.flags |= AlphaBound;
  else if (score > beta)
          new.flags |= BetaBound;
       else
          new.flags |= truescore;
  if ((Mvboard[kingP[side]] == 0) && (Mvboard[qrook[side]] == 0))
    new.flags |= queencastle;
  if ((Mvboard[kingP[side]] == 0) && (Mvboard[krook[side]] == 0))
    new.flags |= kingcastle;
  new.depth = depth;
  new.sh = score >> 8;
  new.sl = score & 0xFF;

  /* for (i = 0; i < frehash; i++)    changed  for to do-while dag */
    i = 0;                            /* init index counter */
  do {                                /* changed for to do  dag */
      fseek(hashfile,
        sizeof(struct fileentry) * ((hashix + 2 * i++) & (filesz - 1)),
        SEEK_SET);              /* i now incremented at usage    dag */
      fread(&tmp, sizeof(struct fileentry), 1, hashfile);
      } while ( new.HashBd != tmp.HashBd && tmp.HashBd != 0 ) ;
                      /* null or equal are real exit conditions
                         may need feof check and reseting later !  dag */
      if (tmp.depth <= depth) /* true for 0 and corrct findings    dag */
       {
        fseek(hashfile,
        sizeof(struct fileentry) * ((hashix + 2 * --i) & (filesz - 1)),
        SEEK_SET);    /* must decrement i for correct write now  dag */
        fwrite(&new, sizeof(struct fileentry), 1, hashfile);
        /*  break;      not needed now   dag */
       }
 /* }    old end of for     dag */
}
#endif /* HASHFILE */
#endif /* ttblsz */

void Px
ZeroRPT (void)           /* added in gc31    dag  */
{
  register int side, i;

  for (side = white; side <= black; side++)
    for (i = 0; i < RPTHSize; i++)
      rpthash[side][i] = 0;
}


#define Link(from,to,flag,s) \
{node->f=from;node->t=to;node->reply=0;node->flags=flag;\
node->score=s;++node;++TrPnt[(ply+1)];}
/*  originaly was   removed spaces for inclusions
    added parens to (ply+1)                  dag
{\
   node->f = from; node->t = to;\
     node->reply = 0;\
       node->flags = flag;\
     node->score = s;\
       ++node;\
         ++TrPnt[(ply+1)];\
         }
*/

#ifdef LINKmMAC
#define LinkMove(ply,f,t,flag,xside)  {REGISTER short s,z,f1;\
REGISTER unsigned short mv;REGISTER struct leaf Fr *node;f1=flag;\
node=&Tree[TrPnt[ply+1]];mv=(f<<8)|t;s=0;if(mv==Swag0)s=2000;else if(mv==Swag1)\
s=60;else if(mv==Swag2)s=50;else if(mv==Swag3)s=40;else if(mv==Swag4)s=30;\
z=(f<<6)|t;if(xside==white)z|=0x1000;s+=(int)history[z];if(color[t]!=neutral)\
{f1|=capture;if(t==TOsquare)s+=500;s+=value[board[t]]-board[f];}\
if(board[f]==pawn)if(row(t)==0||row(t)==7){f1|=promote;s+=800;\
Link(f,t,f1|queen,s-20000);s-=200;Link(f,t,f1|knight,s-20000);s-=50;\
Link(f,t,f1|rook,s-20000);f1|=bishop;s-=50;}else if(row(t)==1||row(t)==6)\
{f1|=pwnthrt;s+=600;}else if(t==epsquare)f1|=epmask;\
Link(f,t,f1,s-2000);\
}

#else

inline void Px
LinkMove (ply, f, t, flag, xside)
     short int ply;
     short int f;
     short int t;
     short int flag;
     short int xside;
/*
  Add a move to the tree.  Assign a bonus to order the moves
  as follows:
  1. Principle variation
  2. Capture of last moved piece
  3. Other captures (major pieces first)
  4. Killer moves
  5. "history" killers
      the code setion was completly uncommented    dag*/

{
  /* trying to correct mysterious side effect bug in macro system, I added
     short f1 and the assignment to passed flag value.   and remanemd usage
     of flag to use f1...  when this function is an inline function
     this should be used too!  It is the source of the 'draw' bug mentioned
     in the unix docs  dag  */
  REGISTER short s, z;
  REGISTER unsigned short mv;
  REGISTER struct leaf Fr *node;

  node = &Tree[TrPnt[ply + 1]];
  mv = (f << 8) | t;
  s = 0;
  if (mv == Swag0)       /*1 principal variations dag */
    s = 2000;
  else if (mv == Swag1)
           s = 60;
       else if (mv == Swag2)
                s = 50;
            else if (mv == Swag3)
                     s = 40;
                 else if (mv == Swag4)
                          s = 30;
  z = (f << 6) | t;
  if (xside == white)         /*  history killers ??  dag */
    z |= 0x1000;
  s += (int) history[z];    /* added cast */
  if (color[t] != neutral) /* 2 capture of last moved piece   dag */
    {
      flag |= capture;
      if (t == TOsquare)   /* TOsquare contains last moved piece */
          s += 500;
      s += value[board[t]] - board[f];   /* 4 capture major pieces */
    }
  if (board[f] == pawn)       /* promotions */
    if (row (t) == 0 || row (t) == 7)
      {
       flag |= promote;
       s += 800;
       Link (f, t, flag | queen, s - 20000);
       s -= 200;
       Link (f, t, flag | knight, s - 20000);
       s -= 50;
       Link (f, t, flag | rook, s - 20000);
       flag |= bishop;
       s -= 50;
      }
    else if (row (t) == 1 || row (t) == 6)
         {
         flag |= pwnthrt;
         s += 600;
         }
         else if (t == epsquare)
                  flag |= epmask;
         s -= 2000;  /* moved out of link call   dag */
     Link (f, t, flag, s );

}
#endif  /* LINKmMAC defined */

/* this macro is complex on MSC 51 and failes with linkmoves
   and link as macros so keep it here for a better compiler.
   works without LINKmMAC defined
   no support for the conditional code used to call linkmove
   in this macro  dag */

#ifdef GENmMAC
   /* Try breaking the macro up into little sections the trailing
    ';' has been removed from each section xcept the last which
    closes the section
    still too big for macro expansion.. try moving the individual
    calls to LinkMove into the inline macro !  dag */

#define GMa(sq)  {REGISTER short u,piece;\
REGISTER unsigned char Fr *ppos,Fr *pdir;short flag0;short fcp;\
flag0=0;fcp=capture;piece=board[sq];\
ppos=nextpos[ptype[side][piece]][sq];pdir=nextdir[ptype[side][piece]][sq];\
if(piece==pawn){u=ppos[sq];if(color[u]==neutral){

#define GMb(sq) u=ppos[u];if(color[u]==neutral)

#define GMb2(sq) }u=pdir[sq];if(color[u]==xside||u==epsquare)

#define GMc(sq)  u=pdir[u];if(color[u]==xside||u==epsquare)

#define GMc2(sq) }else{u=ppos[sq];do{if(color[u]==neutral){

#define GMd(sq) u=ppos[u];}else{if(color[u]==xside)
        /* GMD is the last with a LinkMoves call    dag  */

#define GMe(sq)  u=pdir[u];}}while(u!=sq);}}

/* try assemberling subunits at call site
     sq is the only renamed call so try without parameters
  GMa(sq)
   LinkMove(ply,sq,u,flag0,xside);
  GMb(sq)
    LinkMove(ply,sq,u,flag0,xside);
  GMb2(sq)
    LinkMove(ply,sq,u,fcp,xside);
  GMc(sq)
    LinkMove(ply,sq,u,fcp,xside);
  GMc2(sq)
     LinkMove(ply,sq,u,flag0,xside);
  GMd(sq)
     LinkMove(ply,sq,u,fcp,xside);
  GMe(sq)

       dag */

#else

inline void Px
GenMoves (ply, sq, side, xside)
     short int ply;
     short int sq;
     short int side;
     short int xside;

/*
  Generate moves for a piece. The moves are taken from the precalulated
  array nextpos/nextdir. If the board is free, next move is choosen from
  nextpos else from nextdir.
*/

{
  REGISTER short u, piece;
  REGISTER unsigned char Fr *ppos, Fr *pdir;
#ifdef LINKmMAC   /* this group needed to make a macro of this function dag*/
  short flag0;      /* had to add this to satisfy lvalue required in macro
                       for linkmove    dag */
  short fcp;     /* same and need assignment */

  flag0 = 0;
  fcp = capture;
#endif
  piece = board[sq];
  ppos = nextpos[ptype[side][piece]][sq];
  pdir = nextdir[ptype[side][piece]][sq];
  if (piece == pawn)
    {
      u = ppos[sq];	/* follow no captures thread */
      if (color[u] == neutral)
	{
#ifdef LINKmMAC
      LinkMove (ply, sq, u, flag0, xside);
#else
      LinkMove (ply, sq, u, 0, xside);
#endif
      u = ppos[u];
	  if (color[u] == neutral)
#ifdef LINKmMAC
        LinkMove (ply, sq, u, flag0, xside);
#else
        LinkMove (ply, sq, u, 0, xside);
#endif
    }
      u = pdir[sq];	/* follow captures thread */
      if (color[u] == xside || u == epsquare)
#ifdef LINKmMAC
    LinkMove (ply, sq, u, fcp, xside);
#else
    LinkMove (ply, sq, u, capture, xside);
#endif
      u = pdir[u];
      if (color[u] == xside || u == epsquare)
#ifdef LINKmMAC
    LinkMove (ply, sq, u, fcp, xside);
#else
    LinkMove (ply, sq, u, capture, xside);
#endif
    }
  else
    {
      u = ppos[sq];
      do
	{
	  if (color[u] == neutral)
	    {
#ifdef LINKmMAC
          LinkMove (ply, sq, u, flag0, xside);
#else
          LinkMove (ply, sq, u, 0, xside);
#endif
          u = ppos[u];
	    }
	  else
	    {
          if (color[u] == xside)
#ifdef LINKmMAC
        LinkMove (ply, sq, u, fcp, xside);
#else
        LinkMove (ply, sq, u, capture, xside);
#endif
          u = pdir[u];
	    }
      } while (u != sq);
    }
}
#endif   /* GENmMAC  defined */

void Px
MoveList (side, ply)
     short int side;
     short int ply;

/*
  Fill the array Tree[] with all available moves for side to play. Array
  TrPnt[ply] contains the index into Tree[] of the first move at a ply.
*/

{
  REGISTER short i, xside, f;
             /* had to add this to satisfy lvalue required in macro
                       for linkmove    dag */
#ifdef LINKmMAC
  short fc;          /* was fcstlmask needs assignment */
#endif

#if 0   /* comment out to see if duping is cousing this problem */
#ifdef GENmMAC
  short flag0;      /* had to add this to satisfy lvalue required in macro
                       for linkmove    dag */
  short fcp;        /* was fcapture same and need assignment */

  flag0 = 0;
  fcp = capture;
#endif  /* genmmac defined */
#endif

#ifdef LINKmMAC
  fc = cstlmask;    /* assign default parameter passed */
#endif

  xside = otherside[side];
  TrPnt[ply + 1] = TrPnt[ply];
  if (PV == 0)
    Swag0 = killr0[ply];
  else
    Swag0 = PV;
  Swag1 = killr1[ply];
  Swag2 = killr2[ply];
  Swag3 = killr3[ply];
  Swag4 = 0;
  if (ply > 2)
    Swag4 = killr1[ply - 2];
  for (i = PieceCnt[side]; i >= 0; i--)
#ifdef GENmMAC
     {   /* doing macro assembly inline...   dag   */

      short sq;
      sq = PieceList[side][i];  /* added to simplify macro usage */

  GMa(sq)
    LinkMove(ply,sq,u,flag0,xside);          /* changed 0 to flag0 for call */
  GMb(sq)
    LinkMove(ply,sq,u,flag0,xside);
  GMb2(sq)
    LinkMove(ply,sq,u,fcp,xside);      /* changed to fcp for call */
  GMc(sq)
    LinkMove(ply,sq,u,fcp,xside);
  GMc2(sq)
    LinkMove(ply,sq,u,flag0,xside);
  GMd(sq)
    LinkMove(ply,sq,u,fcp,xside);
  GMe(sq)
      };
#else
    GenMoves (ply, PieceList[side][i], side, xside);
#endif
  if (!castld[side])
    {
      f = PieceList[side][0];
      if (castle (side, f, f + 2, 0))
       {
#ifdef LINKmMAC
        LinkMove (ply, f, (f+2), fc, xside);
#else
        LinkMove (ply, f, f + 2, cstlmask, xside);
#endif
       }
      if (castle (side, f, f - 2, 0))
       {
#ifdef LINKmMAC
        LinkMove (ply, f, (f-2), fc, xside);
#else
        LinkMove (ply, f, f - 2, cstlmask, xside);
#endif
        }
    }
}

void Px
CaptureList (side, xside, ply)
     short int side;
     short int xside;
     short int ply;

/*
  Fill the array Tree[] with all available cature and promote moves for
  side to play. Array TrPnt[ply] contains the index into Tree[]
  of the first move at a ply.
*/

{
  REGISTER short u, sq;
  REGISTER unsigned char Fr *ppos, Fr *pdir;
  short i, piece, *PL, r7;
  struct leaf Fr *node;

  TrPnt[ply + 1] = TrPnt[ply];
  node = &Tree[TrPnt[ply]];
  r7 = rank7[side];
  PL = PieceList[side];
  for (i = 0; i <= PieceCnt[side]; i++)
    {
      sq = PL[i];
      piece = board[sq];
      if (sweep[piece])
      {
	  ppos = nextpos[piece][sq];
	  pdir = nextdir[piece][sq];
	  u = ppos[sq];
	  do
	    {
	      if (color[u] == neutral)
		u = ppos[u];
	      else
		{
          if (color[u] == xside)
		    Link (sq, u, capture,
			  value[board[u]] + svalue[board[u]] - piece);
		  u = pdir[u];
		}
	  } while (u != sq);
	}
      else
	{
	  pdir = nextdir[ptype[side][piece]][sq];
	  if (piece == pawn && row (sq) == r7)
	    {
	      u = pdir[sq];
          if (color[u] == xside)
		Link (sq, u, capture | promote | queen, valueQ);
	      u = pdir[u];
          if (color[u] == xside)
		Link (sq, u, capture | promote | queen, valueQ);
	      ppos = nextpos[ptype[side][piece]][sq];
	      u = ppos[sq]; /* also generate non capture promote */
	      if (color[u] == neutral)
		Link (sq, u, promote | queen, valueQ);
	    }
	  else
	    {
	      u = pdir[sq];
	      do
		{
          if (color[u] == xside)
		    Link (sq, u, capture,
			  value[board[u]] + svalue[board[u]] - piece);
		  u = pdir[u];
	      } while (u != sq);
	    }
	}
    }
}

/*** moved up to here for macro definintion   dag ****/
#ifdef INMACS       /* simulate inline with macros for msc5.1  dag */

#if ttblsz
#define  UpdateHashbd(side, piece, f, t)  {if(f>=0)\
    {hashbd^=hashcode[side][piece][f].bd;\
    hashkey^=hashcode[side][piece][f].key;}if(t>=0)\
    {hashbd^=hashcode[side][piece][t].bd;\
    hashkey^=hashcode[side][piece][t].key;}}
#endif /* ttblsz */

#else

#if ttblsz
void Px
UpdateHashbd (side, piece, f, t)
     short int side;
     short int piece;
     short int f;
     short int t;

/*
  hashbd contains a 32 bit "signature" of the board position. hashkey
  contains a 16 bit code used to address the hash table. When a move is
  made, XOR'ing the hashcode of moved piece on the from and to squares with
  the hashbd and hashkey values keeps things current.

   hashkey is actually a 32 bit value, but only 16 bits of it is used .
   It may be possible to gain a more unique value by Xor-ing this value
   in half... but only maybe    dag

*/

{
  if (f >= 0)
    {
      hashbd ^= hashcode[side][piece][f].bd;
      hashkey ^= hashcode[side][piece][f].key;
    }
  if (t >= 0)
    {
      hashbd ^= hashcode[side][piece][t].bd;
      hashkey ^= hashcode[side][piece][t].key;
    }
}
#endif /* ttblsz */

#endif  /* inmacs defined dag */





int  Px
castle (side, kf, kt, iop)
     short int side;
     short int kf;
     short int kt;
     short int iop;

/* Make or Unmake a castling move. */

{
  REGISTER short rf, rt, t0, xside;

  xside = otherside[side];
  if (kt > kf)
    {
      rf = kf + 3;
      rt = kt - 1;
    }
  else
    {
      rf = kf - 4;
      rt = kt + 1;
    }
  if (iop == 0)
    {
      if (kf != kingP[side] ||
	  board[kf] != king ||
	  board[rf] != rook ||
	  Mvboard[kf] != 0 ||
	  Mvboard[rf] != 0 ||
	  color[kt] != neutral ||
	  color[rt] != neutral ||
	  color[kt - 1] != neutral ||
      SqAtakd (kf, xside) ||
      SqAtakd (kt, xside) ||
      SqAtakd (rt, xside))
	return (false);

    }
  else
    {
      if (iop == 1)
	{
	  castld[side] = true;
	  Mvboard[kf]++;
	  Mvboard[rf]++;
	}
      else
	{
	  castld[side] = false;
	  Mvboard[kf]--;
	  Mvboard[rf]--;
	  t0 = kt;
	  kt = kf;
	  kf = t0;
	  t0 = rt;
	  rt = rf;
	  rf = t0;
	}
      board[kt] = king;
      color[kt] = side;
      Pindex[kt] = 0;
      board[kf] = no_piece;
      color[kf] = neutral;
      board[rt] = rook;
      color[rt] = side;
      Pindex[rt] = Pindex[rf];
      board[rf] = no_piece;
      color[rf] = neutral;
      PieceList[side][Pindex[kt]] = kt;
      PieceList[side][Pindex[rt]] = rt;
#if ttblsz
      if (hashflag)
	{
	  UpdateHashbd (side, king, kf, kt);
	  UpdateHashbd (side, rook, rf, rt);
	}
#endif /* ttblsz */
    }
  return (true);
}


inline void Px
EnPassant (xside, f, t, iop)
     short int xside;
     short int f;
     short int t;
     short int iop;

/*
  Make or unmake an en passant move.
*/

{
  REGISTER short l;

  if (t > f)
    l = t - 8;
  else
    l = t + 8;
  if (iop == 1)
    {
      board[l] = no_piece;
      color[l] = neutral;
    }
  else
    {
      board[l] = pawn;
      color[l] = xside;
    }
  InitializeStats ();
}


inline void Px
UpdatePieceList (side, sq, iop)
     short int side;
     short int sq;
     short int iop;

/*
  Update the PieceList and Pindex arrays when a piece is captured or when a
  capture is unmade.
*/

{
  REGISTER short i;
  if (iop == 1)
    {
      PieceCnt[side]--;
      for (i = Pindex[sq]; i <= PieceCnt[side]; i++)
	{
      PieceList[side][i] = PieceList[side][i + 1];
      Pindex[PieceList[side][i]] = i;
	}
    }
  else
    {
      PieceCnt[side]++;
      PieceList[side][PieceCnt[side]] = sq;
      Pindex[sq] = PieceCnt[side];
    }
}

void Px
MakeMove (side, node, tempb, tempc, tempsf, tempst)
     short int side;
     struct leaf Fr *node;
     short int *tempb;
     short int *tempc;
     short int *tempsf;
     short int *tempst;

/*
  Update Arrays board[], color[], and Pindex[] to reflect the new board
  position obtained after making the move pointed to by node. Also update
  miscellaneous stuff that changes when a move is made.
*/

{
  REGISTER short f, t, xside, ct, cf;

  xside = otherside[side];
  f = node->f;
  t = node->t;
  epsquare = -1;
  FROMsquare = f;
  TOsquare = t;
  INCscore = 0;
  GameList[++GameCnt].gmove = (f << 8) | t;
  if (node->flags & cstlmask)
    {
      GameList[GameCnt].piece = no_piece;
      GameList[GameCnt].color = side;
      (void) castle (side, f, t, 1);
    }
  else
    {
      if (!(node->flags & capture) && (board[f] != pawn))
        rpthash[side][(short) hashkey & RPTHMask]++;
      *tempc = color[t];
      *tempb = board[t];
      *tempsf = svalue[f];
      *tempst = svalue[t];
      GameList[GameCnt].piece = *tempb;
      GameList[GameCnt].color = *tempc;
      if (*tempc != neutral)
	{
	  UpdatePieceList (*tempc, t, 1);
	  if (*tempb == pawn)
	    --PawnCnt[*tempc][column (t)];
	  if (board[f] == pawn)
	    {
	      --PawnCnt[side][column (f)];
	      ++PawnCnt[side][column (t)];
	      cf = column (f);
	      ct = column (t);
	      if (PawnCnt[side][ct] > 1 + PawnCnt[side][cf])
		INCscore -= 15;
	      else if (PawnCnt[side][ct] < 1 + PawnCnt[side][cf])
		INCscore += 15;
	      else if (ct == 0 || ct == 7 || PawnCnt[side][ct + ct - cf] == 0)
		INCscore -= 15;
	    }
      mtl[xside] -= value[*tempb];
	  if (*tempb == pawn)
        pmtl[xside] -= valueP;
#if ttblsz
	  if (hashflag)
        UpdateHashbd (xside, *tempb, -1, t);
#endif /* ttblsz */
	  INCscore += *tempst;
	  Mvboard[t]++;
	}
      color[t] = color[f];
      board[t] = board[f];
      svalue[t] = svalue[f];
      Pindex[t] = Pindex[f];
      PieceList[side][Pindex[t]] = t;
      color[f] = neutral;
      board[f] = no_piece;
      if (board[t] == pawn)
	if (t - f == 16)
	  epsquare = f + 8;
	else if (f - t == 16)
	  epsquare = f - 8;
      if (node->flags & promote)
	{
	  board[t] = node->flags & pmask;
	  if (board[t] == queen)
	    HasQueen[side]++;
	  else if (board[t] == rook)
	    HasRook[side]++;
	  else if (board[t] == bishop)
	    HasBishop[side]++;
	  else if (board[t] == knight)
	    HasKnight[side]++;
	  --PawnCnt[side][column (t)];
	  mtl[side] += value[board[t]] - valueP;
	  pmtl[side] -= valueP;
#if ttblsz
	  if (hashflag)
	    {
	      UpdateHashbd (side, pawn, f, -1);
	      UpdateHashbd (side, board[t], f, -1);
	    }
#endif /* ttblsz */
	  INCscore -= *tempsf;
	}
      if (node->flags & epmask)
    EnPassant (xside, f, t, 1);
      else
#if ttblsz
      if (hashflag)
	UpdateHashbd (side, board[t], f, t);
#endif /* ttblsz */
      Mvboard[f]++;
    }
}

void Px
UnmakeMove (side, node, tempb, tempc, tempsf, tempst)
     short int side;
     struct leaf Fr *node;
     short int *tempb;
     short int *tempc;
     short int *tempsf;
     short int *tempst;

/*
  Take back a move.
*/

{
  REGISTER short f, t, xside;

  xside = otherside[side];
  f = node->f;
  t = node->t;
  epsquare = -1;
  GameCnt--;
  if (node->flags & cstlmask)
    (void) castle (side, f, t, 2);
  else
    {
      color[f] = color[t];
      board[f] = board[t];
      svalue[f] = *tempsf;
      Pindex[f] = Pindex[t];
      PieceList[side][Pindex[f]] = f;
      color[t] = *tempc;
      board[t] = *tempb;
      svalue[t] = *tempst;
      if (node->flags & promote)
	{
	  board[f] = pawn;
	  ++PawnCnt[side][column (t)];
	  mtl[side] += valueP - value[node->flags & pmask];
	  pmtl[side] += valueP;
#if ttblsz
	  if (hashflag)
	    {
	      UpdateHashbd (side, (short) node->flags & pmask, -1, t);
	      UpdateHashbd (side, pawn, -1, t);
	    }
#endif /* ttblsz */
	}
      if (*tempc != neutral)
	{
	  UpdatePieceList (*tempc, t, 2);
	  if (*tempb == pawn)
	    ++PawnCnt[*tempc][column (t)];
	  if (board[f] == pawn)
	    {
	      --PawnCnt[side][column (t)];
	      ++PawnCnt[side][column (f)];
	    }
      mtl[xside] += value[*tempb];
	  if (*tempb == pawn)
        pmtl[xside] += valueP;
#if ttblsz
	  if (hashflag)
        UpdateHashbd (xside, *tempb, -1, t);
#endif /* ttblsz */
	  Mvboard[t]--;
	}
      if (node->flags & epmask)
    EnPassant (xside, f, t, 2);
      else
#if ttblsz
      if (hashflag)
	UpdateHashbd (side, board[f], f, t);
#endif /* ttblsz */
      Mvboard[f]--;
      if (!(node->flags & capture) && (board[f] != pawn))
        rpthash[side][(short) hashkey & RPTHMask]--;
    }
}



void Px
InitializeStats ()

/*
  Scan thru the board seeing what's on each square. If a piece is found,
  update the variables PieceCnt, PawnCnt, Pindex and PieceList. Also
  determine the material for each side and set the hashkey and hashbd
  variables to represent the current board position. Array
  PieceList[side][indx] contains the location of all the pieces of either
  side. Array Pindex[sq] contains the indx into PieceList for a given
  square.
*/

{
  REGISTER short i, sq;
  epsquare = -1;
  for (i = 0; i < 8; i++)
    PawnCnt[white][i] = PawnCnt[black][i] = 0;
  mtl[white] = mtl[black] = pmtl[white] = pmtl[black] = 0;
  PieceCnt[white] = PieceCnt[black] = 0;
#if ttblsz
  hashbd = hashkey = 0;
#endif /* ttblsz */
  for (sq = 0; sq < 64; sq++)
    if (color[sq] != neutral)
      {
	mtl[color[sq]] += value[board[sq]];
	if (board[sq] == pawn)
	  {
	    pmtl[color[sq]] += valueP;
	    ++PawnCnt[color[sq]][column (sq)];
	  }
	if (board[sq] == king)
	  Pindex[sq] = 0;
	else
	  Pindex[sq] = ++PieceCnt[color[sq]];
    PieceList[color[sq]][Pindex[sq]] = sq;
#if ttblsz
	hashbd ^= hashcode[color[sq]][board[sq]][sq].bd;
	hashkey ^= hashcode[color[sq]][board[sq]][sq].key;
#endif /* ttblsz */
      }
}


int  Px
SqAtakd (sq, side)
     short int sq;
     short int side;

/*
  See if any piece with color 'side' ataks sq.  First check pawns then Queen,
  Bishop, Rook and King and last Knight.
*/

{
  REGISTER short u;
  REGISTER unsigned char Fr *ppos, Fr *pdir;
  short xside;

  xside = otherside[side];
  pdir = nextdir[ptype[xside][pawn]][sq];
  u = pdir[sq];		/* follow captures thread */
  if (u != sq)
    {
      if (board[u] == pawn && color[u] == side)
	return (true);
      u = pdir[u];
      if (u != sq && board[u] == pawn && color[u] == side)
	return (true);
    }
  /* king capture */
  if (distance (sq, PieceList[side][0]) == 1)
    return (true);
  /* try a queen bishop capture */
  ppos = nextpos[bishop][sq];
  pdir = nextdir[bishop][sq];
  u = ppos[sq];
  do
    {
      if (color[u] == neutral)
	u = ppos[u];
      else
	{
	  if (color[u] == side &&
	      (board[u] == queen || board[u] == bishop))
	    return (true);
	  u = pdir[u];
	}
  } while (u != sq);
  /* try a queen rook capture */
  ppos = nextpos[rook][sq];
  pdir = nextdir[rook][sq];
  u = ppos[sq];
  do
    {
      if (color[u] == neutral)
	u = ppos[u];
      else
	{
	  if (color[u] == side &&
	      (board[u] == queen || board[u] == rook))
	    return (true);
	  u = pdir[u];
	}
  } while (u != sq);
  /* try a knight capture */
  ppos = nextpos[knight][sq];
  pdir = nextdir[knight][sq];
  u = ppos[sq];
  do
    {
      if (color[u] == side && board[u] == knight)
	return (true);
      u = pdir[u];
  } while (u != sq);
  return (false);
}

#ifdef INMACS
   /* had to remove nomemset defines from this macro */
#define ataks(side,a)  {REGISTER short u,c,sq;\
    REGISTER unsigned char Fr *ppos,Fr *pdir;short i,piece,*PL;\
  memset((char*)a,0,64*sizeof(a[0]));\
  PL=PieceList[side];for(i=PieceCnt[side];i>=0;i--){sq=PL[i];piece=board[sq];\
  c=control[piece];if(sweep[piece]){ppos=nextpos[piece][sq];\
  pdir=nextdir[piece][sq];u=ppos[sq];do{a[u]=++a[u]|c;\
  u=(color[u]==neutral)?ppos[u]:pdir[u];}while(u!=sq);}else\
  {pdir=nextdir[ptype[side][piece]][sq];u=pdir[sq];do{a[u]=++a[u]|c;u=pdir[u];\
  }while(u!=sq);}}}

#else

inline void Px
ataks (side, a)
     short int side;
     short int *a;

/*
  Fill array atak[][] with info about ataks to a square.  Bits 8-15 are set
  if the piece (king..pawn) ataks the square.  Bits 0-7 contain a count of
  total ataks to the square.
*/

{
  REGISTER short u, c, sq;
  REGISTER unsigned char Fr *ppos, Fr *pdir;
  short i, piece, *PL;

#ifdef NOMEMSET
  for (u = 64; u; a[--u] = 0) ;
#else
  memset ((char *) a, 0, 64 * sizeof (a[0]));
#endif /* NOMEMSET */
  PL = PieceList[side];
  for (i = PieceCnt[side]; i >= 0; i--)
    {
      sq = PL[i];
      piece = board[sq];
      c = control[piece];
      if (sweep[piece])
	{
	  ppos = nextpos[piece][sq];
	  pdir = nextdir[piece][sq];
	  u = ppos[sq];
	  do
	    {
	      a[u] = ++a[u] | c;
	      u = (color[u] == neutral) ? ppos[u] : pdir[u];
	  } while (u != sq);
	}
      else
	{
	  pdir = nextdir[ptype[side][piece]][sq];
	  u = pdir[sq];	/* follow captures thread for pawns */
	  do
	    {
	      a[u] = ++a[u] | c;
	      u = pdir[u];
	  } while (u != sq);
	}
    }
}
#endif  /*inmacs defined   dag */


/* ............    POSITIONAL EVALUATION ROUTINES    ............ */

int Px
evaluate (side, xside, ply, alpha, beta)
     short int side;
     short int xside;
     short int ply;
     short int alpha;
     short int beta;

/*
  Compute an estimate of the score by adding the positional score from the
  previous ply to the material difference. If this score falls inside a
  window which is 180 points wider than the alpha-beta window (or within a
  50 point window during quiescence search) call ScorePosition() to
  determine a score, otherwise return the estimated score. If one side has
  only a king and the other either has no pawns or no pieces then the
  function ScoreLoneKing() is called.
*/

{
  REGISTER short evflag;
  short s;

  s = -Pscore[ply - 1] + mtl[side] - mtl[xside] - INCscore;
  hung[white] = hung[black] = 0;
  slk = ((mtl[white] == valueK && (pmtl[black] == 0 || emtl[black] == 0)) ||
	 (mtl[black] == valueK && (pmtl[white] == 0 || emtl[white] == 0)));

  if (slk)
    evflag = false;
  else
    evflag =
      (ply == 1 || ply < Sdepth ||
       ((ply == Sdepth + 1 || ply == Sdepth + 2) &&
	(s > alpha - xwndw && s < beta + xwndw)) ||
       (ply > Sdepth + 2 && s >= alpha - 25 && s <= beta + 25));

  if (evflag)
    {
      EvalNodes++;
      ataks (side, atak[side]);
      if (atak[side][PieceList[xside][0]] > 0)
	return (10001 - ply);
      ataks (xside, atak[xside]);
      InChk = (atak[xside][PieceList[side][0]] > 0);
      ScorePosition (side, &s);
    }
  else
    {
      if (SqAtakd (PieceList[xside][0], side))
	return (10001 - ply);
      InChk = SqAtakd (PieceList[side][0], xside);
      if (slk)
         ScoreLoneKing (side, &s);
    }

  Pscore[ply] = s - mtl[side] + mtl[xside];
  if (InChk)
    ChkFlag[ply - 1] = Pindex[TOsquare];
  else
    ChkFlag[ply - 1] = 0;
  return (s);
}

void Px
ScorePosition (side, score)
     short int side;
     short int *score;

/*
  Perform normal static evaluation of board position. A score is generated
  for each piece and these are summed to get a score for each side.
*/

{
  REGISTER short sq, s, i, xside;
  short pscore[3];

  wking = PieceList[white][0];
  bking = PieceList[black][0];
  UpdateWeights ();
  xside = otherside[side];
  pscore[white] = pscore[black] = 0;

  for (c1 = white; c1 <= black; c1++)
    {
      c2 = otherside[c1];
      if (c1 == white)
	EnemyKing = bking;
      else
	EnemyKing = wking;
      atk1 = atak[c1];
      atk2 = atak[c2];
      PC1 = PawnCnt[c1];
      PC2 = PawnCnt[c2];
      for (i = 0; i <= PieceCnt[c1]; i++)
	{
      sq = PieceList[c1][i];
	  s = SqValue (sq, side);
	  pscore[c1] += s;
	  svalue[sq] = s;
	}
    }
  if (hung[side] > 1)
    pscore[side] += HUNGX;
  if (hung[xside] > 1)
    pscore[xside] += HUNGX;

  *score = mtl[side] - mtl[xside] + pscore[side] - pscore[xside] + 10;
  if (dither)
    *score += rand1 () % dither;

  if (*score > 0 && pmtl[side] == 0)
    if (emtl[side] < valueR)
      *score = 0;
    else if (*score < valueR)
      *score /= 2;
  if (*score < 0 && pmtl[xside] == 0)
    if (emtl[xside] < valueR)
      *score = 0;
    else if (-*score < valueR)
      *score /= 2;

  if (mtl[xside] == valueK && emtl[side] > valueB)
    *score += 200;
  if (mtl[side] == valueK && emtl[xside] > valueB)
    *score -= 200;
}

void Px
ScoreLoneKing (side, score)
     short int side;
     short int *score;

/*
  Static evaluation when loser has only a king and winner has no pawns or no
  pieces.
*/

{
  REGISTER short winner, loser, king1, king2, s, i;

  UpdateWeights ();
  if (mtl[white] > mtl[black])
    winner = white;
  else
    winner = black;
  loser = otherside[winner];
  king1 = PieceList[winner][0];
  king2 = PieceList[loser][0];

  s = 0;

  if (pmtl[winner] > 0)
    for (i = 1; i <= PieceCnt[winner]; i++)
      s += ScoreKPK (side, winner, loser, king1, king2, PieceList[winner][i]);

  else if (emtl[winner] == valueB + valueN)
    s = ScoreKBNK (winner, king1, king2);

  else if (emtl[winner] > valueB)
    s = 500 + emtl[winner] - DyingKing[king2] - 2 * distance (king1, king2);
/*  tried draw code here but failed to achieve a draw   dag */
  if (side == winner)
    *score = s;
  else
    *score = -s;
}


int Px
ScoreKPK (side, winner, loser, king1, king2, sq)
     short int side;
     short int winner;
     short int loser;
     short int king1;
     short int king2;
     short int sq;

/*
  Score King and Pawns versus King endings.
*/

{
  REGISTER short s, r;

  if (PieceCnt[winner] == 1)
    s = 50;
  else
    s = 120;
  if (winner == white)
    {
      if (side == loser)
	r = row (sq) - 1;
      else
	r = row (sq);
      if (row (king2) >= r && distance (sq, king2) < 8 - r)
	s += 10 * row (sq);
      else
	s = 500 + 50 * row (sq);
      if (row (sq) < 6)
	sq += 16;
      else
        if (row(sq) == 6)   /* if added in 31   dag */
           sq += 8;
    }
  else
    {
      if (side == loser)
	r = row (sq) + 1;
      else
	r = row (sq);
      if (row (king2) <= r && distance (sq, king2) < r + 1)
	s += 10 * (7 - row (sq));
      else
	s = 500 + 50 * (7 - row (sq));
      if (row (sq) > 1)
	sq -= 16;
      else  if ( row(sq) == 1)   /* if updated in 31   dag */
             sq -= 8;
    }
  s += 8 * (taxicab (king2, sq) - taxicab (king1, sq));
  return (s);
}


int Px
ScoreKBNK (winner, king1, king2)
     short int winner;
     short int king1;
     short int king2;


/*
  Score King+Bishop+Knight versus King endings.
  This doesn't work all that well but it's better than nothing.
*/

{
  REGISTER short s;

  s = emtl[winner] - 300;
  if (KBNKsq == 0)
    s += KBNK[king2];
  else
    s += KBNK[locn (row (king2), 7 - column (king2))];
  s -= taxicab (king1, king2);
  s -= distance (PieceList[winner][1], king2);
  s -= distance (PieceList[winner][2], king2);
  return (s);
}

#ifdef BRSMAC
#define BRscan(sq,s,mob) {REGISTER short u, piece, pin;\
  REGISTER unsigned char Fr *ppos, Fr *pdir;\
  short *Kf;\
  Kf = Kfield[c1];\
  *mob = 0;\
  piece = board[sq];\
  ppos = nextpos[piece][sq];\
  pdir = nextdir[piece][sq];\
  u = ppos[sq];\
  pin = -1;\
  do\
    {\
      *s += Kf[u];\
      if (color[u] == neutral)\
    {\
      (*mob)++;\
      if (ppos[u] == pdir[u])\
        pin = -1;\
      u = ppos[u];\
    }\
      else if (pin < 0)\
    {\
      if (board[u] == pawn || board[u] == king)\
        u = pdir[u];\
      else\
        {\
          if (ppos[u] != pdir[u])\
        pin = u;\
          u = ppos[u];\
        }\
    }\
      else\
    {\
      if (color[u] == c2 && (board[u] > piece || atk2[u] == 0))\
        {\
          if (color[pin] == c2)\
        {\
          *s += PINVAL;\
          if (atk2[pin] == 0 ||\
              atk1[pin] > control[board[pin]] + 1)\
            ++hung[c2];\
        }\
          else\
        *s += XRAY;\
        }\
      pin = -1;\
      u = pdir[u];\
    }\
  } while (u != sq);\
}


#else

inline void Px
BRscan (sq, s, mob)
     short int sq;
     short int *s;
     short int *mob;

/*
  Find Bishop and Rook mobility, XRAY attacks, and pins. Increment the
  hung[] array if a pin is found.
*/
{
  REGISTER short u, piece, pin;
  REGISTER unsigned char Fr *ppos, Fr *pdir;
  short *Kf;

  Kf = Kfield[c1];
  *mob = 0;
  piece = board[sq];
  ppos = nextpos[piece][sq];
  pdir = nextdir[piece][sq];
  u = ppos[sq];
  pin = -1;			/* start new direction */
  do
    {
      *s += Kf[u];
      if (color[u] == neutral)
	{
	  (*mob)++;
	  if (ppos[u] == pdir[u])
	    pin = -1;		/* oops new direction */
	  u = ppos[u];
	}
      else if (pin < 0)
	{
	  if (board[u] == pawn || board[u] == king)
	    u = pdir[u];
	  else
	    {
	      if (ppos[u] != pdir[u])
		pin = u;	/* not on the edge and on to find a pin */
	      u = ppos[u];
	    }
	}
      else
	{
	  if (color[u] == c2 && (board[u] > piece || atk2[u] == 0))
	    {
	      if (color[pin] == c2)
		{
		  *s += PINVAL;
		  if (atk2[pin] == 0 ||
		      atk1[pin] > control[board[pin]] + 1)
		    ++hung[c2];
		}
	      else
		*s += XRAY;
	    }
	  pin = -1;		/* new direction */
	  u = pdir[u];
	}
  } while (u != sq);
}
#endif  /* BRSMAC defined   dag */

int Px
SqValue (sq, side)
     short int sq;
     short int side;

/*
  Calculate the positional value for the piece on 'sq'.
*/

{
  REGISTER short j, fyle, rank;
  short s, piece, a1, a2, in_square, r, mob, e, c;

  piece = board[sq];
  a1 = (atk1[sq] & 0x4FFF);
  a2 = (atk2[sq] & 0x4FFF);
  rank = row (sq);
  fyle = column (sq);
  s = 0;
  if (piece == pawn && c1 == white)
    {
      s = Mwpawn[sq];
      if (sq == 11 || sq == 12)
	if (color[sq + 8] != neutral)
	  s += PEDRNK2B;
      if ((fyle == 0 || PC1[fyle - 1] == 0) &&
	  (fyle == 7 || PC1[fyle + 1] == 0))
	s += ISOLANI[fyle];
      else if (PC1[fyle] > 1)
	s += PDOUBLED;
      if (a1 < ctlP && atk1[sq + 8] < ctlP)
	{
	  s += BACKWARD[a2 & 0xFF];
	  if (PC2[fyle] == 0)
	    s += PWEAKH;
	  if (color[sq + 8] != neutral)
	    s += PBLOK;
	}
      if (PC2[fyle] == 0)
	{
	  if (side == black)
	    r = rank - 1;
	  else
	    r = rank;
	  in_square = (row (bking) >= r && distance (sq, bking) < 8 - r);
	  if (a2 == 0 || side == white)
	    e = 0;
	  else
	    e = 1;
	  for (j = sq + 8; j < 64; j += 8)
	    if (atk2[j] >= ctlP)
	      {
		e = 2;
		break;
	      }
	    else if (atk2[j] > 0 || color[j] != neutral)
	      e = 1;
	  if (e == 2)
	    s += (stage * PassedPawn3[rank]) / 10;
	  else if (in_square || e == 1)
	    s += (stage * PassedPawn2[rank]) / 10;
	  else if (emtl[black] > 0)
	    s += (stage * PassedPawn1[rank]) / 10;
	  else
	    s += PassedPawn0[rank];
	}
    }
  else if (piece == pawn && c1 == black)
    {
      s = Mbpawn[sq];
      if (sq == 51 || sq == 52)
	if (color[sq - 8] != neutral)
	  s += PEDRNK2B;
    if ((fyle == 0 || PC1[fyle - 1] == 0) &&
	  (fyle == 7 || PC1[fyle + 1] == 0))
        s += ISOLANI[fyle];
    else if (PC1[fyle] > 1)
          s += PDOUBLED;
    if (a1 < ctlP && atk1[sq - 8] < ctlP)
	{
	  s += BACKWARD[a2 & 0xFF];
	  if (PC2[fyle] == 0)
	    s += PWEAKH;
	  if (color[sq - 8] != neutral)
	    s += PBLOK;
	}
    if (PC2[fyle] == 0)
     {
	  if (side == white)
	    r = rank + 1;
	  else
	    r = rank;
	  in_square = (row (wking) <= r && distance (sq, wking) < r + 1);
	  if (a2 == 0 || side == black)
	    e = 0;
	  else
	    e = 1;
	  for (j = sq - 8; j >= 0; j -= 8)
	    if (atk2[j] >= ctlP)
	      {
           e = 2;
           break;
	      }
	    else if (atk2[j] > 0 || color[j] != neutral)
                 e = 1;
	  if (e == 2)
	    s += (stage * PassedPawn3[7 - rank]) / 10;
	  else if (in_square || e == 1)
              s += (stage * PassedPawn2[7 - rank]) / 10;
           else if (emtl[white] > 0)
                  s += (stage * PassedPawn1[7 - rank]) / 10;
                else
                  s += PassedPawn0[7 - rank];
     }
    }
  else if (piece == knight)
       {
       s = Mknight[c1][sq];
       }
       else if (piece == bishop)
         {
          s = Mbishop[c1][sq];
          BRscan (sq, &s, &mob);
          s += BMBLTY[mob];
         }
        else if (piece == rook)
         {
          s += RookBonus;
          BRscan (sq, &s, &mob);
          s += RMBLTY[mob];
          if (PC1[fyle] == 0)
              s += RHOPN;
          if (PC2[fyle] == 0)
              s += RHOPNX;
          if (rank == rank7[c1] && pmtl[c2] > 100)
              s += 10;
          if (stage > 2)
             s += 14 - taxicab (sq, EnemyKing);
         }
          else if (piece == queen)
           {
            if (stage > 2)
               s += 14 - taxicab (sq, EnemyKing);
            if (distance (sq, EnemyKing) < 3)
               s += 12;
           }
          else if (piece == king)
           {
            s = Mking[c1][sq];
            if (KSFTY > 0)
             if (Developed[c2] || stage > 0)
                 KingScan (sq, &s);
            if (castld[c1])
                s += KCASTLD;
            else if (Mvboard[kingP[c1]])
                   s += KMOVD;

            if (PC1[fyle] == 0)
                s += KHOPN;
            if (PC2[fyle] == 0)
                s += KHOPNX;
            if (fyle == 1 || fyle == 2 || fyle == 3 || fyle == 7)
             {
              if (PC1[fyle - 1] == 0)
                  s += KHOPN;
              if (PC2[fyle - 1] == 0)
                  s += KHOPNX;
             }
           if (fyle == 4 || fyle == 5 || fyle == 6 || fyle == 0)
            {
             if (PC1[fyle + 1] == 0)
                  s += KHOPN;
             if (PC2[fyle + 1] == 0)
                  s += KHOPNX;
            }
          if (fyle == 2)
           {
           if (PC1[0] == 0)
              s += KHOPN;
           if (PC2[0] == 0)
              s += KHOPNX;
           }
          if (fyle == 5)
           {
           if (PC1[7] == 0)
               s += KHOPN;
           if (PC2[7] == 0)
               s += KHOPNX;
           }
    }
  if (a2 > 0)
    {
      c = (control[piece] & 0x4FFF);
      if (a1 == 0 || a2 > c + 1)
	{
	  s += HUNGP;
	  ++hung[c1];
	  if (piece != king && trapped (sq, piece))
	    ++hung[c1];
	}
      else if (piece != pawn || a2 > a1)
	if (a2 >= c || a1 < ctlP)
	  s += ATAKD;
    }
  return (s);
}

void Px
KingScan (sq, s)
     short int sq;
     short int *s;

/*
  Assign penalties if king can be threatened by checks, if squares
  near the king are controlled by the enemy (especially the queen),
  or if there are no pawns near the king.
  The following must be true:
  board[sq] == king
  c1 == color[sq]
  c2 == otherside[c1]
*/

#define ScoreThreat \
if (color[u] != c2)\
  if (atk1[u] == 0 || (atk2[u] & 0xFF) > 1) ++cnt;\
  else *s -= 3

{
  REGISTER short u;
  REGISTER unsigned char Fr *ppos, Fr *pdir;
  REGISTER short cnt, ok;

  cnt = 0;
  if (HasBishop[c2] || HasQueen[c2])
    {
      ppos = nextpos[bishop][sq];
      pdir = nextdir[bishop][sq];
      u = ppos[sq];
      do
	{
	  if (atk2[u] & ctlBQ)
	    ScoreThreat;
	  u = (color[u] == neutral) ? ppos[u] : pdir[u];
      } while (u != sq);
    }
  if (HasRook[c2] || HasQueen[c2])
    {
      ppos = nextpos[rook][sq];
      pdir = nextdir[rook][sq];
      u = ppos[sq];
      do
	{
	  if (atk2[u] & ctlRQ)
	    ScoreThreat;
	  u = (color[u] == neutral) ? ppos[u] : pdir[u];
      } while (u != sq);
    }
  if (HasKnight[c2])
    {
      pdir = nextdir[knight][sq];
      u = pdir[sq];
      do
	{
	  if (atk2[u] & ctlNN)
	    ScoreThreat;
	  u = pdir[u];
      } while (u != sq);
    }
  *s += (KSFTY * KTHRT[cnt]) / 16;

  cnt = 0;
  ok = false;
  pdir = nextpos[king][sq];
  u = pdir[sq];
  do
    {
      if (board[u] == pawn)
	ok = true;
      if (atk2[u] > atk1[u])
	{
	  ++cnt;
	  if (atk2[u] & ctlQ)
	    if (atk2[u] > ctlQ + 1 && atk1[u] < ctlQ)
	      *s -= 4 * KSFTY;
	}
      u = pdir[u];
  } while (u != sq);
  if (!ok)
    *s -= KSFTY;
  if (cnt > 1)
    *s -= KSFTY;
}


int  Px
trapped (sq, piece)
     short int sq;
     short int piece;

/*
  See if the attacked piece has unattacked squares to move to.
  The following must be true:
  piece == board[sq]
  c1 == color[sq]
  c2 == otherside[c1]
*/

{
  REGISTER short u;
  REGISTER unsigned char Fr *ppos, Fr *pdir;

  ppos = nextpos[ptype[c1][piece]][sq];
  pdir = nextdir[ptype[c1][piece]][sq];
  if (piece == pawn)
    {
      u = ppos[sq];	/* follow no captures thread */
      if (color[u] == neutral)
	{
	  if (atk1[u] >= atk2[u])
	    return (false);
	  if (atk2[u] < ctlP)
	    {
	      u = ppos[u];
	      if (color[u] == neutral && atk1[u] >= atk2[u])
		return (false);
	    }
	}
      u = pdir[sq];	/* follow captures thread */
      if (color[u] == c2)
	return (false);
      u = pdir[u];
      if (color[u] == c2)
	return (false);
    }
  else
    {
      u = ppos[sq];
      do
	{
	  if (color[u] != c1)
	    if (atk2[u] == 0 || board[u] >= piece)
	      return (false);
	  u = (color[u] == neutral) ? ppos[u] : pdir[u];
      } while (u != sq);
    }
  return (true);
}

#ifdef BLENDbMAC
#define BlendBoard(a,b,c) {\
  REGISTER int sq;\
  for (sq = 0; sq < 64; sq++)\
    c[sq] = (a[sq] * (10 - stage) + b[sq] * stage) / 10;\
}

#else

inline void Px
BlendBoard (a, b, c)
     const short int *a;
     const short int *b;
     short int *c;
{
  REGISTER int sq;

  for (sq = 0; sq < 64; sq++)
    c[sq] = (a[sq] * (10 - stage) + b[sq] * stage) / 10;
}
#endif /* BLENDbMAC mac defined */

#ifdef COPYbMAC
#define CopyBoard(a,b)  {\
  REGISTER int sq;\
  for (sq = 0; sq < 64; sq++)\
    b[sq] = a[sq];\
}

#else

inline void Px
CopyBoard (a, b)
     const short int *a;
     short int *b;
{
  REGISTER int sq;

  for (sq = 0; sq < 64; sq++)
    b[sq] = a[sq];
}
#endif   /* COPYbMAC defined */

void Px
ExaminePosition ()

/*
  This is done one time before the search is started. Set up arrays
  Mwpawn, Mbpawn, Mknight, Mbishop, Mking which are used in the
  SqValue() function to determine the positional value of each piece.
*/

{
  REGISTER short i, sq;
  short wpadv, bpadv, wstrong, bstrong, z, side, pp, j, k, val, Pd, fyle, rank;

  wking = PieceList[white][0];
  bking = PieceList[black][0];
  ataks (white, atak[white]);
  ataks (black, atak[black]);
  Zwmtl = Zbmtl = 0;
  UpdateWeights ();
  HasPawn[white] = HasPawn[black] = 0;
  HasKnight[white] = HasKnight[black] = 0;
  HasBishop[white] = HasBishop[black] = 0;
  HasRook[white] = HasRook[black] = 0;
  HasQueen[white] = HasQueen[black] = 0;
  for (side = white; side <= black; side++)
    for (i = 0; i <= PieceCnt[side]; i++)
      switch (board[PieceList[side][i]])
	{
	case pawn:
	  ++HasPawn[side];
	  break;
	case knight:
	  ++HasKnight[side];
	  break;
	case bishop:
	  ++HasBishop[side];
	  break;
	case rook:
	  ++HasRook[side];
	  break;
	case queen:
	  ++HasQueen[side];
	  break;
	}
  if (!Developed[white])
    Developed[white] = (board[1] != knight && board[2] != bishop &&
			board[5] != bishop && board[6] != knight);
  if (!Developed[black])
    Developed[black] = (board[57] != knight && board[58] != bishop &&
			board[61] != bishop && board[62] != knight);
  if (!PawnStorm && stage < 5)
    PawnStorm = ((column (wking) < 3 && column (bking) > 4) ||
		 (column (wking) > 4 && column (bking) < 3));

  CopyBoard (pknight, Mknight[white]);
  CopyBoard (pknight, Mknight[black]);
  CopyBoard (pbishop, Mbishop[white]);
  CopyBoard (pbishop, Mbishop[black]);
  BlendBoard (KingOpening, KingEnding, Mking[white]);
  BlendBoard (KingOpening, KingEnding, Mking[black]);

  for (sq = 0; sq < 64; sq++)
    {
      fyle = column (sq);
      rank = row (sq);
      wstrong = bstrong = true;
      for (i = sq; i < 64; i += 8)
	if (atak[black][i] >= ctlP)
	  {
	    wstrong = false;
	    break;
	  }
      for (i = sq; i >= 0; i -= 8)
	if (atak[white][i] >= ctlP)
	  {
	    bstrong = false;
	    break;
	  }
      wpadv = bpadv = PADVNCM;
      if ((fyle == 0 || PawnCnt[white][fyle - 1] == 0) &&
	  (fyle == 7 || PawnCnt[white][fyle + 1] == 0))
	wpadv = PADVNCI;
      if ((fyle == 0 || PawnCnt[black][fyle - 1] == 0) &&
	  (fyle == 7 || PawnCnt[black][fyle + 1] == 0))
	bpadv = PADVNCI;
      Mwpawn[sq] = (wpadv * PawnAdvance[sq]) / 10;
      Mbpawn[sq] = (bpadv * PawnAdvance[63 - sq]) / 10;
      Mwpawn[sq] += PawnBonus;
      Mbpawn[sq] += PawnBonus;
      if (Mvboard[kingP[white]])
	{
	  if ((fyle < 3 || fyle > 4) && distance (sq, wking) < 3)
	    Mwpawn[sq] += PAWNSHIELD;
	}
      else if (rank < 3 && (fyle < 2 || fyle > 5))
	Mwpawn[sq] += PAWNSHIELD / 2;
      if (Mvboard[kingP[black]])
	{
	  if ((fyle < 3 || fyle > 4) && distance (sq, bking) < 3)
	    Mbpawn[sq] += PAWNSHIELD;
	}
      else if (rank > 4 && (fyle < 2 || fyle > 5))
	Mbpawn[sq] += PAWNSHIELD / 2;
      if (PawnStorm)
	{
	  if ((column (wking) < 4 && fyle > 4) ||
	      (column (wking) > 3 && fyle < 3))
	    Mwpawn[sq] += 3 * rank - 21;
	  if ((column (bking) < 4 && fyle > 4) ||
	      (column (bking) > 3 && fyle < 3))
	    Mbpawn[sq] -= 3 * rank;
	}
      Mknight[white][sq] += 5 - distance (sq, bking);
      Mknight[white][sq] += 5 - distance (sq, wking);
      Mknight[black][sq] += 5 - distance (sq, wking);
      Mknight[black][sq] += 5 - distance (sq, bking);
      Mbishop[white][sq] += BishopBonus;
      Mbishop[black][sq] += BishopBonus;
      for (i = 0; i <= PieceCnt[black]; i++)
    if (distance (sq, PieceList[black][i]) < 3)
	  Mknight[white][sq] += KNIGHTPOST;
      for (i = 0; i <= PieceCnt[white]; i++)
    if (distance (sq, PieceList[white][i]) < 3)
	  Mknight[black][sq] += KNIGHTPOST;
      if (wstrong)
	Mknight[white][sq] += KNIGHTSTRONG;
      if (bstrong)
	Mknight[black][sq] += KNIGHTSTRONG;
      if (wstrong)
	Mbishop[white][sq] += BISHOPSTRONG;
      if (bstrong)
	Mbishop[black][sq] += BISHOPSTRONG;

      if (HasBishop[white] == 2)
	Mbishop[white][sq] += 8;
      if (HasBishop[black] == 2)
	Mbishop[black][sq] += 8;
      if (HasKnight[white] == 2)
	Mknight[white][sq] += 5;
      if (HasKnight[black] == 2)
	Mknight[black][sq] += 5;

      if (board[sq] == bishop)
	if (rank % 2 == fyle % 2)
	  KBNKsq = 0;
	else
	  KBNKsq = 7;

      Kfield[white][sq] = Kfield[black][sq] = 0;
      if (distance (sq, wking) == 1)
	Kfield[black][sq] = KATAK;
      if (distance (sq, bking) == 1)
	Kfield[white][sq] = KATAK;

      Pd = 0;
      for (k = 0; k <= PieceCnt[white]; k++)
	{
      i = PieceList[white][k];
	  if (board[i] == pawn)
	    {
	      pp = true;
	      if (row (i) == 6)
		z = i + 8;
	      else
		z = i + 16;
	      for (j = i + 8; j < 64; j += 8)
		if (atak[black][j] > ctlP || board[j] == pawn)
		  {
		    pp = false;
		    break;
		  }
	      if (pp)
		Pd += 5 * taxicab (sq, z);
	      else
		Pd += taxicab (sq, z);
	    }
	}
      for (k = 0; k <= PieceCnt[black]; k++)
	{
      i = PieceList[black][k];
	  if (board[i] == pawn)
	    {
	      pp = true;
	      if (row (i) == 1)
		z = i - 8;
	      else
		z = i - 16;
	      for (j = i - 8; j >= 0; j -= 8)
		if (atak[white][j] > ctlP || board[j] == pawn)
		  {
		    pp = false;
		    break;
		  }
	      if (pp)
		Pd += 5 * taxicab (sq, z);
	      else
		Pd += taxicab (sq, z);
	    }
	}
      if (Pd != 0)
	{
	  val = (Pd * stage2) / 10;
	  Mking[white][sq] -= val;
	  Mking[black][sq] -= val;
	}
    }
}

void Px
UpdateWeights ()

/*
  If material balance has changed, determine the values for the positional
  evaluation terms.
*/

{
  REGISTER short tmtl, s1;

  if (mtl[white] != Zwmtl || mtl[black] != Zbmtl)
    {
      Zwmtl = mtl[white];
      Zbmtl = mtl[black];
      emtl[white] = Zwmtl - pmtl[white] - valueK;
      emtl[black] = Zbmtl - pmtl[black] - valueK;
      tmtl = emtl[white] + emtl[black];
      s1 = (tmtl > 6600) ? 0 : ((tmtl < 1400) ? 10 : (6600 - tmtl) / 520);
      if (s1 != stage)
	{
	  stage = s1;
	  stage2 = (tmtl > 3600) ? 0 : ((tmtl < 1400) ? 10 : (3600 - tmtl) / 220);
	  PEDRNK2B = -15;	/* centre pawn on 2nd rank & blocked */
	  PBLOK = -4;		/* blocked backward pawn */
	  PDOUBLED = -14;	/* doubled pawn */
	  PWEAKH = -4;		/* weak pawn on half open file */
	  PAWNSHIELD = 10 - stage;	/* pawn near friendly king */
	  PADVNCM = 10;		/* advanced pawn multiplier */
	  PADVNCI = 7;		/* muliplier for isolated pawn */
	  PawnBonus = stage;

	  KNIGHTPOST = (stage + 2) / 3;	/* knight near enemy pieces */
	  KNIGHTSTRONG = (stage + 6) / 2;	/* occupies pawn hole */

	  BISHOPSTRONG = (stage + 6) / 2;	/* occupies pawn hole */
	  BishopBonus = 2 * stage;

	  RHOPN = 10;		/* rook on half open file */
	  RHOPNX = 4;
	  RookBonus = 6 * stage;

	  XRAY = 8;		/* Xray attack on piece */
	  PINVAL = 10;		/* Pin */

	  KHOPN = (3 * stage - 30) / 2;	/* king on half open file */
	  KHOPNX = KHOPN / 2;
	  KCASTLD = 10 - stage;
	  KMOVD = -40 / (stage + 1);	/* king moved before castling */
	  KATAK = (10 - stage) / 2;	/* B,R attacks near enemy king */
	  if (stage < 8)
	    KSFTY = 16 - 2 * stage;
	  else
	    KSFTY = 0;

	  ATAKD = -6;		/* defender > attacker */
	  HUNGP = -8;		/* each hung piece */
	  HUNGX = -12;		/* extra for >1 hung piece */
	}
    }
}

